/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: if_ppp.h 1.7 2017/6/1 8:49:13 abe $
 */

/*
 * if_ppp.h - Point-to-Point Protocol definitions.
 *
 * Copyright (c) 1989 Carnegie Mellon University.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted
 * provided that the above copyright notice and this paragraph are
 * duplicated in all such forms and that any documentation,
 * advertising materials, and other materials related to such
 * distribution and use acknowledge that the software was developed
 * by Carnegie Mellon University.  The name of the
 * University may not be used to endorse or promote products derived
 * from this software without specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 * $FreeBSD: src/sys/net/if_ppp.h,v 1.13.2.1 1999/08/29 16:28:21 peter Exp $
 */

#ifndef _IF_PPP_H_
#define _IF_PPP_H_

#ifdef SUPPORT_PPP

/*
 *  PPP ɥ쥹ʥߡ
 */

typedef struct t_ppp_addr {
	uint8_t		lladdr[0];
	} T_PPP_ADDR;

/*
 *  󥿥եޥ
 */

#define T_IF_HDR		T_PPP_HDR		/* 󥿥եΥإå		*/
#define T_IF_ADDR		T_PPP_ADDR		/* 󥿥եΥɥ쥹			*/
#define IF_HDR_ALIGN		2			/* إåΥ饤ñ			*/
#define IF_MTU			DEF_PPP_MTU		/* 󥿥ե MTU			*/

#define IF_OUTPUT(o,d,g,t)	ppp_output(o,t)		/* 󥿥եνϴؿ		*/
#define IF_RAW_OUTPUT(o,t)	ppp_output(o,t)		/* 󥿥եνϴؿɥ쥹̵*/
#define IF_SET_PROTO(b,p)	(*GET_PPP_HDR(b) = htons(p))
							/* 󥿥եΥץȥؿ	*/
#define IF_SOFTC_TO_IFADDR(s)	((T_IF_ADDR*)(s)->ifaddr.lladdr)
							/* եȥ󤫤 PPP ɥ쥹Ф	*/
#define IF_GET_IFNET()		ppp_get_ifnet()		/* ͥåȥ󥿥ե¤Τ֤*/
#define IF_SRAND()		(0)			/* 󥿡ե			*/

/* IPv4 ط */

#define IF_PROTO_IP		PPP_IP			/* 󥿥ե IPv4 ץȥ	*/

/* IPv6 ط */

#define MAX_IF_MADDR_CNT	0			/* 󥿥եΥޥ㥹ȥɥ쥹κ祵*/
#define IF_PROTO_IPV6		PPP_IPV6		/* 󥿥ե IPv6 ץȥ	*/
#define IF_IN6_NEED_CACHE(i)	(false)			/* õåѤ롣	*/
#define IF_IN6_IFID(i,a)	get_rand_ifid(i,a)	/* 󥿥ե̻Ҥ		*/
#define IF_IN6_RESOLVE_MULTICAST(i,m)	{}		/* 󥿥եΥޥ㥹ȥɥ쥹ؤѴ		*/

/*
 *  MTU (MRU) ˴ؤ
 */

#define DEF_PPP_MTU		1500	/* PPP  ɸ MTU	*/
#define MAX_PPP_MTU		16384	/* PPP   MTU	*/
#define MIN_PPP_MTU		128	/* PPP  Ǿ MTU	*/

/*
 *  PPP إå
 */

typedef uint16_t T_PPP_HDR;				/* ̥ץȥ		*/

/*
 *  
 */

#ifndef T_IFNET_DEFINED

typedef struct t_ifnet T_IFNET;

#define T_IFNET_DEFINED

#endif	/* of #ifndef T_IFNET_DEFINED */

#ifndef T_IF_SOFTC_DEFINED

typedef struct t_if_softc T_IF_SOFTC;

#define T_IF_SOFTC_DEFINED

#endif	/* of #ifndef T_IF_SOFTC_DEFINED */

#ifndef T_NET_BUF_DEFINED

typedef struct t_net_buf T_NET_BUF;

#define T_NET_BUF_DEFINED

#endif	/* of #ifndef T_NET_BUF_DEFINED */

/*
 *  ͥåȥ󥿥ե˰¸ʤեȥ
 */

struct t_if_softc {
	T_IF_ADDR	ifaddr;		/* ͥåȥ󥿥եΥɥ쥹	*/
	};

/*
 *  ؿ
 */

extern T_IFNET *ppp_get_ifnet (void);
ER ppp_output (T_NET_BUF *data, TMO tmout);

#endif	/* of #ifdef SUPPORT_PPP */

#endif	/* of #ifndef _IF_PPP_H_ */
