/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dhcp6.h 1.7 2017/6/1 8:50:20 abe $
 */

#ifndef DHCP6_H
#define DHCP6_H

/*
 *  DHCPv6 ˴ؤ
 *
 *    RFC3315
 */

/*
 *  DHCPv6 å
 */

#define DHCP6_XID_LEN		3
#define DHCP6_OPTION_LEN	(512-(1+DHCP6_XID_LEN))

/*
 *  DHCPv6 å
 */

typedef struct dhcp6_msg_hdr {
	uint8_t	type;				/* message type		*/
	uint8_t	xid[DHCP6_XID_LEN];		/* transaction ID	*/
	} T_DHCP6_MSG_HDR;

typedef struct dhcp6_msg {
	T_DHCP6_MSG_HDR	hdr;
	uint8_t		options[DHCP6_OPTION_LEN];	/* options	*/
	} T_DHCP6_MSG;

/* message type  */

#define DHCP6_SOLICIT		UINT_C(1)
#define DHCP6_ADVERTISE		UINT_C(2)
#define DHCP6_REQUEST		UINT_C(3)
#define DHCP6_CONFIRM		UINT_C(4)
#define DHCP6_RENEW		UINT_C(5)
#define DHCP6_REBIND		UINT_C(6)
#define DHCP6_REPLY		UINT_C(7)
#define DHCP6_RELEASE		UINT_C(8)
#define DHCP6_DECLINE		UINT_C(9)
#define DHCP6_RECONFIGURE	UINT_C(10)
#define DHCP6_INFO_REQ		UINT_C(11)
#define DHCP6_RELAY_FORW	UINT_C(12)
#define DHCP6_RELAY_REPL	UINT_C(13)

/*
 *  DHCPv6 ץ
 */

#define DHCP6_OPT_CLIENTID	UINT_C(1)
#define DHCP6_OPT_SERVERID	UINT_C(2)
#define DHCP6_OPT_IA_NA		UINT_C(3)
#define DHCP6_OPT_IA_TA		UINT_C(4)
#define DHCP6_OPT_IAADDR	UINT_C(5)
#define DHCP6_OPT_ORO		UINT_C(6)
#define DHCP6_OPT_PREFERENCE	UINT_C(7)
#define DHCP6_OPT_UNICAST	UINT_C(12)
#define DHCP6_OPT_STATUS_CODE	UINT_C(13)
#define DHCP6_OPT_RAPID_COMMIT	UINT_C(14)
#define DHCP6_OPT_NAME_SERVERS	UINT_C(23)
#define DHCP6_OPT_DOMAIN_SEARCH	UINT_C(24)
#define DHCP6_OPT_IA_PD		UINT_C(25)

/* hardware address type  */

#define DHCP6_HWA_TYPE_ETHER	UINT_C(1)
#define DHCP6_HWA_TYPE_IEEE802	UINT_C(6)

/* STATUS CODE  */

#define DHCP6_STAT_SUCCESS	UINT_C(0)
#define DHCP6_STAT_UNSPECIFID	UINT_C(1)
#define DHCP6_STAT_NO_AVAIL	UINT_C(2)
#define DHCP6_STAT_NO_BINDING	UINT_C(3)
#define DHCP6_STAT_NO_ONLINK	UINT_C(4)
#define DHCP6_STAT_USE_MCAST	UINT_C(5)

/* [s] */

#define DHCP6_MAX_TIME		UINT_C(0xffffffff)

/*
 *  ץΥإå
 */

/* ץζ */

typedef struct dhcp6_option {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	} T_DHCP6_OPTION;

/* ץζ */

/* CLIENTID ץ */

typedef struct dhcp6_opt_clientid {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	} T_DHCP6_OPT_CLIENTID;

/* SERVERID ץ */

typedef struct dhcp6_opt_serverid {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	} T_DHCP6_OPT_SERVERID;

/* IA_NA/IA_PD ץ */

typedef struct dhcp6_opt_ia_na_pd {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	uint32_t	iaid;		/* IA ID		*/
	uint32_t	renew;		/* renew  timeout (T1)	*/
	uint32_t	rebind;		/* rebind timeout (T2)	*/
	} T_DHCP6_OPT_IA_NA_PD;

/* IA_TA ץ */

typedef struct dhcp6_opt_ia_ta {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	uint32_t	iaid;		/* IA ID		*/
	} T_DHCP6_OPT_IA_TA;

/* IAADDR ץ */

#ifdef T_IN6_ADDR_DEFINED

typedef struct dhcp6_opt_iaaddr {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	T_IN6_ADDR	addr;		/* IPv6 address		*/
	uint32_t	prefer;		/* preferred lifetime	*/
	uint32_t	valid;		/* valid     lifetime	*/
	} T_DHCP6_OPT_IAADDR;

#endif	/* of #ifdef T_IN6_ADDR_DEFINED */

/* ORO ץ */

typedef struct dhcp6_opt_oro {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	} T_DHCP6_OPT_ORO;

/* PREFERENCE ץ */

typedef struct dhcp6_opt_preference {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	uint8_t		prefer;		/* preference value	*/
	} T_DHCP6_OPT_PREFERENCE;

/* UNICAST ץ */

#ifdef T_IN6_ADDR_DEFINED

typedef struct dhcp6_opt_unicast {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	T_IN6_ADDR	addr;		/* IPv6 address for server*/
	} T_DHCP6_OPT_UNICAST;

#endif	/* of #ifdef T_IN6_ADDR_DEFINED */

/* STATUS CODE ץ */

typedef struct dhcp6_opt_status_code {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	uint16_t	status;		/* status code		*/
	} T_DHCP6_OPT_STATUS_CODE;

/* NAME SERVERS ץ */

typedef struct dhcp6_opt_name_servers {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	T_IN6_ADDR	addrs[1];	/* IPv6 address		*/
	} T_DHCP6_OPT_NAME_SERVERS;

/* DOMAIN SEARCH ץ */

typedef struct dhcp6_opt_domain_search {
	uint16_t	code;		/* option code		*/
	uint16_t	len;		/* option length	*/
	uint8_t		name[1];	/* domain search	*/
	} T_DHCP6_OPT_DOMAIN_SEARCH;

/*
 *  DHCPv6 ߥRFC3315 5.5 ȡ
 *  ¾Υߥ dhcp6_cli.h 
 */

#ifdef SYSTIM_HZ

#define TMO_SOL_MAX_DELAY	(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_SOL_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_SOL_MAX_RT		(120*SYSTIM_HZ)	/* 120[s] 	*/
#define TMO_REQ_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_REQ_MAX_RT		(30*SYSTIM_HZ)	/*  30[s] 	*/
#define TMO_REQ_MAX_RC		10		/* 	*/
#define TMO_CNF_MAX_DELAY	(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_CNF_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_CNF_MAX_RT		(4*SYSTIM_HZ)	/*   4[s] 	*/
#define TMO_CNF_MAX_RD		(10*SYSTIM_HZ)	/*  10[s] 	*/
#define TMO_REN_TIMEOUT		(10*SYSTIM_HZ)	/*  10[s] 	*/
#define TMO_REN_MAX_RT		(600*SYSTIM_HZ)	/* 600[s] 	*/
#define TMO_REB_TIMEOUT		(10*SYSTIM_HZ)	/*  10[s] 	*/
#define TMO_REB_MAX_RT		(600*SYSTIM_HZ)	/* 600[s] 	*/
#define TMO_INF_MAX_DELAY	(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_INF_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_INF_MAX_RT		(120*SYSTIM_HZ)	/* 120[s] 	*/
#define TMO_REL_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_REL_MAX_RC		5		/* 	*/
#define TMO_DEC_TIMEOUT		(1*SYSTIM_HZ)	/*   1[s] 	*/
#define TMO_DEC_MAX_RC		5		/* 	*/
#define TMO_REC_TIMEOUT		(2*SYSTIM_HZ)	/*   2[s] 	*/
#define TMO_REC_MAX_RC		8		/* 	*/

#endif	/* of #ifdef SYSTIM_HZ */

/*
 *  DUID -- DHCP Unique ID
 */

/* DUID_LLT ¤ */

typedef struct dhcp6_duid_llt_hdr {
	uint16_t	code;		/* DUID code		*/
	uint16_t	type;		/* hardware type	*/
	uint32_t	time;		/* time			*/
	} T_DHCP6_DUID_LLT_HDR;

/* DUID_LL ¤ */

typedef struct dhcp6_duid_ll_hdr {
	uint16_t	code;		/* DUID code		*/
	uint16_t	type;		/* hardware type	*/
	} T_DHCP6_DUID_LL_HDR;

/* DUID סRFC3315 9ȡ*/

#define DUID_LLT		1
#define DUID_EN			2
#define DUID_LL			3

/*
 *  DUID ֤Ĵ
 *  DUID ֤γϤ 2001/1/1
 */

#define DUID_TIME_EPOCH		0

/* 졼žκۥå׿ */

#define HOP_COUNT_LIMIT		32

/*
 *  IPv6 ɥ쥹
 */

#define IPV6_ADDR_ALL_DHCP_RELAY_SERVERS_INIT	\
	{{{ UINT_C(0xff), UINT_C(0x02), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x01), UINT_C(0x00), UINT_C(0x02) }}}

#define IPV6_ADDR_ALL_DHCP_SERVERS_INIT	\
	{{{ UINT_C(0xff), UINT_C(0x05), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), UINT_C(0x00), \
	    UINT_C(0x00), UINT_C(0x01), UINT_C(0x00), UINT_C(0x03) }}}

/*
 *  UDP ݡֹ
 */

#ifndef DHCP6_SRV_CFG_PORTNO
#define DHCP6_SRV_CFG_PORTNO	547	/* server	*/
#endif

#ifndef DHCP6_CLI_CFG_PORTNO
#define DHCP6_CLI_CFG_PORTNO	546	/* client	*/
#endif

#endif	/* of #ifndef DHCP6_H */
