/*
 * Copyright (c) 2004-2011 by Internet Systems Consortium, Inc. ("ISC")
 * Copyright (c) 1995-2003 by Internet Software Consortium
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND ISC DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL ISC BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *   Internet Systems Consortium, Inc.
 *   950 Charter Street
 *   Redwood City, CA 94063
 *   <info@isc.org>
 *   https://www.isc.org/
 *
 * This code is based on the original client state machine that was
 * written by Elliot Poger.  The code has been extensively hacked on
 * by Ted Lemon since then, so any mistakes you find are probably his
 * fault and not Elliot's.
 */
/*
 * WIDE Project DHCP Implementation
 * Copyright (c) 1995-1997 Akihiro Tominaga
 * Copyright (c) 1995-1997 WIDE Project
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided the following conditions
 * are satisfied,
 *
 * 1. Both the copyright notice and this permission notice appear in
 *    all copies of the software, derivative works or modified versions,
 *    and any portions thereof, and that both notices appear in
 *    supporting documentation.
 * 2. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by WIDE Project and
 *      its contributors.
 * 3. Neither the name of WIDE Project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE DEVELOPER ``AS IS'' AND WIDE
 * PROJECT DISCLAIMS ANY LIABILITY OF ANY KIND FOR ANY DAMAGES
 * WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE. ALSO, THERE
 * IS NO WARRANTY IMPLIED OR OTHERWISE, NOR IS SUPPORT PROVIDED.
 *
 * Feedback of the results generated from any improvements or
 * extensions made to this software would be much appreciated.
 * Any such feedback should be sent to:
 * 
 *  Akihiro Tominaga
 *  WIDE Project
 *  Keio University, Endo 5322, Kanagawa, Japan
 *  (E-mail: dhcp-dist@wide.ad.jp)
 *
 * WIDE project has the rights to redistribute these changes.
 */
/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2011 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: dhcp6_cli.h 1.7 2017/6/1 8:50:20 abe $
 */

#ifndef DHCP6_CLI_H
#define DHCP6_CLI_H

#ifdef DHCP6_CLI_CFG

#include <netinet/in.h>
#include <netapp/dhcp6.h>

/* 
 *  DHCP 饤ȤΥå
 */

#define DHCP6_CLI_STACK_SIZE		1024		/* DHCP 饤ȥΥå	*/

/* 
 *  DHCP 饤Ȥͥ
 */

#define DHCP6_CLI_MAIN_PRIORITY		5		/* DHCP 饤ȥͥ		*/

/* 
 *  ѥե졼
 */

/*
 *  DHCPv6 ư⡼
 *
 *    #define DHCP6_CLI_CFG_MODE ǻꤹ롣
 *    ꤵƤʤСơȥ쥹ꤹ롣
 *
 */

#define DHCP6_CLI_CFG_STATELESS		0	/* ơȥ쥹ꤹ롣		*/
#define DHCP6_CLI_CFG_STATEFULL		1	/* ơȥեꤹ롣		*/
#define DHCP6_CLI_CFG_RA		2	/* RA  M/O ӥåȤˤꤹ롣	*/
#define DHCP6_CLI_CFG_MODE_DEFAULT	DHCP6_CLI_CFG_STATELESS

/* IA  */
#define DHCP6_CLI_CFG_IA_NA		1
//#define DHCP6_CLI_CFG_IA_TA		1
//#define DHCP6_CLI_CFG_IA_PD		1

/* Rapid-commit λ */
//#define DHCP6_CLI_CFG_RAPID_COMMIT	1

/* 侩٤ */
#define DHCP6_CLI_CFG_PREFER_IA		50	/* IA_NA/TA/PD ο侩	*/
#define DHCP6_CLI_CFG_PREFER_IAADDR	100	/* ɥ쥹ο侩	*/

/* DHCPv6 饤ȥåμꥹȥ2ʾꤹ뤳ȡ */
#define NUM_DHCP6_CLI_MSG_LIST		3

/*
 *  DHCPv6 饤ȥå¤οѹػߡ
 *  +1 
 */
#define NUM_MPF_DHCP6_CLI_MSG		(NUM_DHCP6_CLI_MSG_LIST+1)

/* DHCP ɬܥץꥹ */

#ifndef DHCP6_CLI_CFG_REQUIRED_OLIST

#if defined(USE_RESOLVER)

#define DHCP6_CLI_CFG_REQUIRED_OLIST {	\
	DHCP6_OPT_NAME_SERVERS,		\
	}

#else	/* of #if defined(USE_RESOLVER) */

#endif	/* of #if defined(USE_RESOLVER) */

#endif	/* of #ifndef DHCP6_CLI_CFG_REQUIRED_OLIST */

/* DHCP ׵ᥪץꥹ */

#ifndef DHCP6_CLI_CFG_REQUEST_OLIST

#if defined(USE_RESOLVER)

#define DHCP6_CLI_CFG_REQUEST_OLIST {	\
	DHCP6_OPT_DOMAIN_SEARCH,	\
	}

#else	/* of #if defined(USE_RESOLVER) */

#endif	/* of #if defined(USE_RESOLVER) */

#endif	/* of #ifndef DHCP6_CLI_CFG_REQUEST_OLIST */

/*
 *  ॢ
 *  RFC3315 ˵ꤵ줿ߥ dhcp6.h 
 */

/* ɸåκॢ	*/
#define TMO_DHCP6C_NORMAL	ULONG_C(60*1000)

/* ɸ׵꡼			*/
#define TMO_DHCP6C_REQ_LEASE	ULONG_C(7200*1000)

/* å¤γॢ	*/
#define TMO_DHCP6C_MPF_GET	ULONG_C(1000)

/* åॢ	*/
#define TMO_DHCP6C_RCV_DAT	ULONG_C(1000)

/*
 *  DHCPv6 饤ȥå¤
 */

typedef struct dhcp6_cli_msg {
	/* 4Хȶ˥饤󤹤롣*/
	T_DHCP6_MSG		msg;		/* DHCPv6 å¤	*/
	struct dhcp6_cli_msg	*next;		/* ꥹȤμΥå¤	*/
	SYSTIM			rcv_time;	/* 			*/
	T_IPV6EP		srv;		/* ФIPv6ɥ쥹/ݡֹ */
	uint16_t		len;		/* msg ͭĹ			*/
	uint16_t		prefer;		/* msg ο侩			*/
	uint16_t		status;		/* STATUS CODE ץ status */
	} T_DHCP6_CLI_MSG;

/* prefer Υե饰 */

#define DHCP6_ClI_MSG_PREFER_ADDR	UINT_C(0x8000)	/* ɥ쥹󤢤		*/
#define DHCP6_ClI_MSG_PREFER_REQUIRED	UINT_C(0x4000)	/* ɬܥץ󤢤		*/
#define DHCP6_ClI_MSG_PREFER_REQUEST	UINT_C(0x2000)	/* ׵ᥪץ󤢤		*/
#define DHCP6_ClI_MSG_PREFER_OPTION	UINT_C(0x1000)	/* PREFER ץ󤢤	*/
#define DHCP6_ClI_MSG_PREFER_FLAG_MASK	UINT_C(0xf000)
#define DHCP6_ClI_MSG_PREFER_VALUE_MASK	(~(DHCP6_ClI_MSG_PREFER_FLAG_MASK))

/*
 *  STATUS CODE ץ̵
 */

#define DHCP6_CLI_STAT_UNDEFINED	(-1)

/*
 *  Хåؿ
 */

extern ER callback_nblk_dhcp6_cli (ID cepid, FN fncd, void *p_parblk);

/*
 *  
 */

extern void	dhcp6_cli_task(intptr_t exinf);

/*
 *  ؿ
 */

extern ER dhcp6c_rel_info (void);
extern ER dhcp6c_renew_info (void);
extern ER dhcp6c_get_info (T_IN6_ADDR *addr, uint32_t *expire, uint32_t *renew,
                                             uint32_t *rebind, uint32_t *deprefer, SYSTIM *bind_start);

#endif	/* of #ifdef DHCP6_CLI_CFG */

#endif	/* of #ifndef DHCP6_CLI_H */
