/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: netapp_var.h 1.7 2017/6/1 8:50:23 abe $
 */

#ifndef _NETAPP_VAR_H_
#define _NETAPP_VAR_H_

/*
 *  TOPPERS/JSP ͥ롢ƥ (SYSTIM) μȿ
 */

#define SYSTIM_HZ		ULONG_C(1000)	/* [ms]					*/

/*
 *  IPv6/IPv4 ˴ؤ
 */

/*
 *  ꤵ줿ޥФ륵ץ륢ץꥱΥޥ
 *
 *    SUPPORT_INET6		 .   .  ON  ON  ON  ON
 *    SUPPORT_INET4		ON  ON   .   .  ON  ON
 *    API_CFG_IP4MAPPED_ADDR	 .  ON   .  ON   .  ON
 *    ----------------------    ----------------------
 *    NETAPP_IP6_CFG             .   .  ON  ON  ON  ON
 *    NETAPP_IP4_CFG            ON  ON   .  ON  ON  ON
 *    
 */

#if defined(SUPPORT_INET6)

#define	NETAPP_IP6_CFG

#endif	/* #if defined(SUPPORT_INET6) */

#if defined(SUPPORT_INET4) || (defined(SUPPORT_INET6) && defined(API_CFG_IP4MAPPED_ADDR))
#define NETAPP_IP4_CFG
#endif

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

#define DBG_LINE_SIZE		63

#if defined(SUPPORT_INET6)

#define T_IN_ADDR		T_IN6_ADDR
#define T_IPEP			T_IPV6EP
#define IP_ADDRANY		IPV6_ADDRANY
#define T_TCPN_CREP		T_TCP6_CREP

#else	/* of #if defined(SUPPORT_INET6) */

#define T_IN_ADDR		T_IN4_ADDR
#define T_IPEP			T_IPV4EP
#define IP_ADDRANY		IPV4_ADDRANY
#define T_TCPN_CREP		T_TCP_CREP

#endif	/* of #if defined(SUPPORT_INET6) */

/*
 *  API IPץȥλ
 */

#if defined(SUPPORT_INET6)
#define DEFAULT_API_PROTO	API_PROTO_IPV6
#else
#define DEFAULT_API_PROTO	API_PROTO_IPV4
#endif

/*
 *  resolv_hoststr ֤ flags ͤ
 *
 *    :
 *
 *      dns.h Ƥ DNS_OPCODE
 *      resolver.h Ƥ DNS_LUP_FLAGS ȽŤʤʤ
 */

#define HOSTSTR_OTHER		0x0000U
#define HOSTSTR_IPV4		DNS_LUP_FLAGS_NAME_IPV4
#define HOSTSTR_IPV6		DNS_LUP_FLAGS_NAME_IPV6
#define HOSTSTR_HOSTNAME	DNS_LUP_FLAGS_NAME_HOST
#define HOSTSTR_FQDN		DNS_LUP_FLAGS_NAME_FQDN

/*
 *  
 */

#define DBG_LINE_SIZE		63

#if defined(SUPPORT_INET6)

#define NUM_VRID_TCP_CEPS	NUM_VRID_TCP6_CEPS

#else	/* of #if defined(SUPPORT_INET6) */

#define NUM_VRID_TCP_CEPS	NUM_VRID_TCP4_CEPS

#endif	/* of #if defined(SUPPORT_INET6) */

/*
 *  ؿߥ졼ޥ
 */

/* åɽФ */

#define MSG2HOST16(p)		(msg2host16((void*)&(p)))
#define MSG2HOST32(p)		(msg2host32((void*)&(p)))

/* åؤν */

#define HOST2MSG16(p,v)		(host2msg16((void*)&(p),(v)))
#define HOST2MSG32(p,v)		(host2msg32((void*)&(p),(v)))

/*
 *  ͥåȥͳ󥽡
 */

#ifdef USE_NET_CONS

/* ͡ */

#define syslog		net_syslog
#define serial_ctl_por	net_serial_ctl_por

/* ؿߥ졼ޥ */

#define FLUSH_SND_BUFF()	flush_snd_buff()
#define WAI_NET_CONS_PRINTF()	syscall(wai_sem(SEM_NET_CONS_PRINTF))
#define SIG_NET_CONS_PRINTF()	sig_sem(SEM_NET_CONS_PRINTF)

#else	/* of #ifdef USE_NET_CONS */

/* ؿߥ졼ޥ */

#define FLUSH_SND_BUFF()
#define WAI_NET_CONS_PRINTF()
#define SIG_NET_CONS_PRINTF()

#endif	/* of #ifdef USE_NET_CONS */

/*
 *  ؿ
 */

extern const char *in_strtfn (FN fncd);
extern const char *itron_strerror (ER ercd);
extern const char *dns_strtype (uint_t type);
extern const char *dns_strclass (uint_t class);
extern ER	net_syslog(uint_t prio, const char *format, ...) throw();
extern ER	net_serial_ctl_por(ID portid, uint_t ioctl) throw();
extern void	flush_snd_buff (void);
extern ER	discon_net_cons (void);
extern void	wup_net_cons (void);
extern bool_t	tcp6_is_cepid (ID cepid);
extern ER	alloc_tcp6_rep (ID *repid, ID tskid, T_TCP6_CREP *crep);
extern ER	alloc_tcp6_cep (ID *cepid, ID tskid, T_TCP_CCEP *ccep);
extern ER	alloc_udp6_cep (ID *cepid, ID tskid, T_UDP6_CCEP *ccep);
extern ER	free_tcp6_rep (ID repid, bool_t call_tcp_del_rep);
extern ER	free_tcp6_cep (ID cepid);
extern ER	free_udp6_cep (ID cepid, bool_t call_udp_del_cep);
extern bool_t	tcp4_is_cepid (ID cepid);
extern ER	alloc_tcp4_rep (ID *repid, ID tskid, T_TCP_CREP *crep);
extern ER	alloc_tcp4_cep (ID *cepid, ID tskid, T_TCP_CCEP *ccep);
extern ER	alloc_udp4_cep (ID *cepid, ID tskid, T_UDP_CCEP *ccep);
extern ER	free_tcp4_rep (ID repid, bool_t call_tcp_del_rep);
extern ER	free_tcp4_cep (ID cepid);
extern ER	free_udp4_cep (ID cepid, bool_t call_udp_del_cep);
extern void	ping6 (T_IN6_ADDR *addr, uint_t tmo, uint_t len);
extern void	ping4 (T_IN4_ADDR *addr, uint_t tmo, uint_t len);
extern char	*get_ipv6addr (T_IN6_ADDR *addr, char *line);
extern char	*get_ipv4addr (T_IN4_ADDR *addr, char *line);
extern char	*resolv_options (uint_t *flags, char *line, char apip);
extern char	*resolv_hoststr (uint_t *flags, char *hostname, uint_t name_size, char *line);
extern char	*lookup_ipaddr (T_IN_ADDR *addr, char *line, char apip);
extern uint_t	show_dns_domain_name (ID portid, uint8_t *hdr, uint_t offset);
extern void	host2msg16 (void *msg, uint16_t host_data);
extern void	host2msg32 (void *msg, uint32_t host_data);
extern uint16_t	msg2host16 (void *msg);
extern uint32_t	msg2host32 (void *msg);
extern uint32_t	netapp_rand (void);
extern void	netapp_srand (uint32_t seed);

#if defined(SUPPORT_INET6)

#define TCP_CRE_REP(i,r)	tcp6_cre_rep(i,r)
#define TCP_CRE_CEP(i,c)	tcp6_cre_cep(i,c)
#define UDP_CRE_CEP(i,c)	udp6_cre_cep(i,c)
#define TCP_ACP_CEP(c,r,d,t)	tcp6_acp_cep(c,r,d,t)
#define TCP_CON_CEP(c,m,d,t)	tcp6_con_cep(c,m,d,t)

#define UDP_SND_DAT(c,d,b,l,t)	udp6_snd_dat(c,d,b,l,t)
#define UDP_RCV_DAT(c,d,b,l,t)	udp6_rcv_dat(c,d,b,l,t)

#define TCP_IS_CEPID(i)		tcp6_is_cepid(i)
#define ALLOC_TCP_REP(i,t,r)	alloc_tcp6_rep(i,t,r)
#define ALLOC_TCP_CEP(i,t,c)	alloc_tcp6_cep(i,t,c)
#define ALLOC_UDP_CEP(i,t,c)	alloc_udp6_cep(i,t,c)
#define FREE_TCP_REP(i,r)	free_tcp6_rep(i,r)
#define FREE_TCP_CEP(i)		free_tcp6_cep(i)
#define FREE_UDP_CEP(i,c)	free_udp6_cep(i,c)

#define IP2STR(s,a)		ipv62str(s,a)
#define GET_IPADDR(a,l)		get_ipv6addr(a,l)
#define PING(a,t,l)		ping6(a,t,l)

#else	/* of #if defined(SUPPORT_INET6) */

#if defined(SUPPORT_INET4)

#define TCP_CRE_REP(i,r)	tcp_cre_rep(i,r)
#define TCP_CRE_CEP(i,c)	tcp_cre_cep(i,c)
#define UDP_CRE_CEP(i,c)	udp_cre_cep(i,c)
#define TCP_ACP_CEP(c,r,d,t)	tcp_acp_cep(c,r,d,t)
#define TCP_CON_CEP(c,m,d,t)	tcp_con_cep(c,m,d,t)

#define UDP_SND_DAT(c,d,b,l,t)	udp_snd_dat(c,d,b,l,t)
#define UDP_RCV_DAT(c,d,b,l,t)	udp_rcv_dat(c,d,b,l,t)

#define TCP_IS_CEPID(i)		tcp4_is_cepid(i)
#define ALLOC_TCP_REP(i,t,r)	alloc_tcp4_rep(i,t,r)
#define ALLOC_TCP_CEP(i,t,c)	alloc_tcp4_cep(i,t,c)
#define ALLOC_UDP_CEP(i,t,c)	alloc_udp4_cep(i,t,c)
#define FREE_TCP_REP(i,r)	free_tcp4_rep(i,r)
#define FREE_TCP_CEP(i)		free_tcp4_cep(i)
#define FREE_UDP_CEP(i,c)	free_udp4_cep(i,c)

#define IP2STR(s,a)		ip2str(s,a)
#define GET_IPADDR(a,l)		get_ipv4addr(a,l)
#define PING(a,t,l)		ping4(a,t,l)

#endif	/* of #if defined(SUPPORT_INET4) */

#endif	/* of #if defined(SUPPORT_INET6) */

#endif	/* of #ifndef _NETAPP_VAR_H_ */
