/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: resolver.h 1.7 2017/6/1 8:50:23 abe $
 */

/*
 *  ۥ̾IP ɥ쥹Ѵ
 */

#ifndef RESOLVER_H
#define RESOLVER_H

#include <netapp/dns.h>

/*
 *  ѥե졼λ
 */

/* ݡֹ */

#define RSLV_CFG_DNS_PORTNO	53

/*
 *  ॢ
 */

#define TMO_DNS_UDP_SND		ULONG_C(1*1000)	/* [ms]DNS Фؤ   UDP ॢ	*/
#define TMO_DNS_UDP_RCV		ULONG_C(5*1000)	/* [ms]DNS Ф UDP ॢ	*/
#define NUM_DNS_UDP_RETRY	1		/* ȥ饤					*/

/*
 *  ɥᥤ̾
 */


#if !defined(RSLV_CFG_DNS_DOMAIN_NAME_STR)
#define RSLV_CFG_DNS_DOMAIN_NAME_STR	""
#endif

/*
 *  DNS С IPɥ쥹
 */

#if !defined(IPV6_ADDR_DNS_INIT)
#define IPV6_ADDR_DNS_INIT	IPV6_ADDR_UNSPECIFIED_INIT
#endif

#if !defined(IPV4_ADDR_DNS)
#define	IPV4_ADDR_DNS		IPV4_ADDRANY
#endif

/*
 *  Хåե
 */

#define NUM_MPF_RSLV_SRBUF	1

/*
 *  ץǻѤ
 */

/*
 *  ץǻѤ DNS إå
 *
 *    : ФϥۥȥХȥ
 *
 *    0                    7  8                   15
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |                      ID                       |
 *  +--+-----------+--+--+--+--+--------+-----------+
 *  |QR|   Opcode  |AA|TC|RD|RA|    Z   |   RCODE   |
 *  +--+--------+--+--+--+--+--+--------+-----------+
 *  |                    QDCOUNT                    |
 *  +-----------------------------------------------+
 *  |                    ANCOUNT                    |
 *  +-----------------------------------------------+
 *  |                    NSCOUNT                    |
 *  +-----------------------------------------------+
 *  |                    ARCOUNT                    |
 *  +-----------------------------------------------+
 */

typedef struct rslv_dns_hdr {
	uint16_t	id;		/* ID */
	uint16_t	code;	/* QR:		1
				   Opcode:	4
				   AA:		1
				   TC:		1
				   RD:		1
				   RA:		1
				   Z:		3
				   RCODE:	4
				   */
	uint16_t	qdcount;	/* question   section */
	uint16_t	ancount;	/* answer     section */
	uint16_t	nscount;	/* authority  section */
	uint16_t	arcount;	/* additional section */
	} T_RSLV_DNS_HDR;

/*
 *  DNS message data
 *
 *    : ФϥۥȥХȥ
 */

typedef struct rslv_dns_msg {
	T_RSLV_DNS_HDR	dns_hdr;	/* DNS heder                            */
	uint_t		qd_offset;	/* offset of question           section */
	uint_t		an_offset;	/* offset of answer             section */
	uint_t		ns_offset;	/* offset of authority  records section */
	uint_t		ar_offset;	/* offset of additional records section */
	} T_RSLV_DNS_MSG;

/*
 *  RR (Resouce Record) 
 *
 *    0                    7  8                   15
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |                       .                       |
 *  +-----------------      .      -----------------+
 *  |                      NAME                     |
 *  +-----------------      .      -----------------+
 *  |                       .                       |
 *  +-----------------------------------------------+
 *  |                      TYPE                     |
 *  +-----------------------------------------------+
 *  |                      CLASS                    |
 *  +-----------------------------------------------+
 *  |                       TTL                     |
 *  |                                               |
 *  +-----------------------------------------------+
 *  |                    RDLENGTH                   |
 *  +-----------------------------------------------+
 *  |                       .                       |
 *  +-----------------      .      -----------------+
 *  |                     RDATA                     |
 *  +-----------------      .      -----------------+
 *  |                       .                       |
 *  +-----------------------------------------------+
 *
 *    : offset θ DNS message Ƭ
 *          ФϥۥȥХȥ
 */

typedef struct rslv_rr {
	uint16_t	type;		/* TYPE			*/
	uint16_t	class;		/* CLASS		*/
	uint32_t	ttl;		/* TTL			*/
	uint16_t	rdlength;	/* RDATA length		*/
	uint_t		rdata_offset;	/* offset of RDATA	*/
	} T_RSLV_RR;

/*
 *  Question section 
 *
 *    0                    7  8                   15
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |                       .                       |
 *  +-----------------      .      -----------------+
 *  |                     QNAME                     |
 *  +-----------------      .      -----------------+
 *  |                       .                       |
 *  +-----------------------------------------------+
 *  |                     QTYPE                     |
 *  +-----------------------------------------------+
 *  |                     QCLASS                    |
 *  +-----------------------------------------------+
 *
 *    : ФϥۥȥХȥ
 */

typedef struct rslv_qd {
	uint16_t	type;		/* TYPE			*/
	uint16_t	class;		/* CLASS		*/
	} T_RSLV_QD;

/*
 *  SOA RDATA 
 *
 *    0                    7  8                   15
 *  +--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+--+
 *  |                       .                       |
 *  +-----------------      .      -----------------+
 *  |                     MNAME                     |
 *  +-----------------      .      -----------------+
 *  |                       .                       |
 *  +-----------------------------------------------+
 *  |                       .                       |
 *  +-----------------      .      -----------------+
 *  |                     RNAME                     |
 *  +-----------------      .      -----------------+
 *  |                       .                       |
 *  +-----------------------------------------------+
 *  |                    SERIAL                     |
 *  |                                               |
 *  +-----------------------------------------------+
 *  |                    REFRESH                    |
 *  |                                               |
 *  +-----------------------------------------------+
 *  |                     RETRY                     |
 *  |                                               |
 *  +-----------------------------------------------+
 *  |                    EXPIRE                     |
 *  |                                               |
 *  +-----------------------------------------------+
 *  |                    MINIMUM                    |
 *  |                                               |
 *  +-----------------------------------------------+
 *
 *    : offset θ DNS message Ƭ
 *          ФϥۥȥХȥ
 */

typedef struct rslv_soa {
	uint32_t	serial;		/* SERIAL		*/
	uint32_t	refresh;	/* REFRESH		*/
	uint32_t	retry;		/* RETRY		*/
	uint32_t	expire;		/* EXPIRE		*/
	uint32_t	minimum;	/* MINIMUM		*/
	} T_RSLV_SOA;

/*
 *  dns_lookup_host  flags 
 *
 *    :
 *      dns.h Ƥ DNS_OPCODE ȽŤʤʤȡ
 *      #define DNS_OPCODE_MASK		0x7800U
 */

#define DNS_LUP_FLAGS_NAME_IPV4		0x0004U
#define DNS_LUP_FLAGS_NAME_IPV6		0x0006U
#define DNS_LUP_FLAGS_NAME_HOST		0x0010U
#define DNS_LUP_FLAGS_NAME_FQDN		0x0011U
#define DNS_LUP_FLAGS_NAME_MASK		0x001fU

#define DNS_LUP_OPCODE_FORWARD		DNS_OPCODE_FORWARD
#define DNS_LUP_OPCODE_REVERSE		DNS_OPCODE_REVERSE
#define DNS_LUP_OPCODE_STATUS		DNS_OPCODE_STATUS
#define DNS_LUP_OPCODE_MASK		DNS_OPCODE_MASK

#define DNS_LUP_FLAGS_PROTO_IPV4	0x0040U
#define DNS_LUP_FLAGS_PROTO_IPV6	0x0080U
#define DNS_LUP_FLAGS_PROTO_MASK	0x00c0U

#define DNS_LUP_FLAGS_QTYPE_A		0x0100U
#define DNS_LUP_FLAGS_QTYPE_AAAA	0x0200U
#define DNS_LUP_FLAGS_QTYPE_PTR		0x0400U
#define DNS_LUP_FLAGS_QTYPE_MASK	0x0700U

#define DNS_LUP_FLAGS_MSG		0x0020U

/*
 *  ͥåȥ顼
 */

#define EV_RSLV_ESIZE			(-100)		/* DNSå̾Ĺ۾	*/
#define EV_RSLV_UNEXPCT			(-101)		/* ͽʤDNSå	*/

/*
 *  ؿ
 */

extern ER_UINT	dns_lookup_host (uint16_t flags, char *hostname, uint8_t *msg, uint_t msg_len, T_RSLV_DNS_MSG *rslv);
extern ER	dns_host_addr (uint16_t flags, char *hostname, T_IN_ADDR *addr);
extern ER_UINT	dns_analyze_qd (T_RSLV_QD *qd, uint_t offset, uint8_t *msg, uint_t length);
extern ER_UINT	dns_analyze_rr (T_RSLV_RR *rr, uint_t offset, uint8_t *msg, uint_t length);
extern ER_UINT	dns_analyze_soa (T_RSLV_SOA *soa, uint_t offset, uint8_t *msg, uint_t length);

/*
 *  : dns_in6_set_dnamedns_in4_set_dname
 *        dns_in6_set_addr dns_in4_set_addr ǡ
 *        new  NULL ꤹȡ᤹ͤ
 */

extern const uint8_t *dns_in6_set_dname (const uint8_t *new, uint_t len);
extern const uint8_t *dns_in6_get_dname (void);
extern const uint8_t *dns_in4_set_dname (const uint8_t *new, uint_t len);
extern const uint8_t *dns_in4_get_dname (void);
extern T_IN6_ADDR *dns_in6_set_addr (T_IN6_ADDR *new);
extern T_IN6_ADDR *dns_in6_get_addr (T_IN6_ADDR *dst);
extern T_IN4_ADDR *dns_in4_set_addr (T_IN4_ADDR *new);
extern T_IN4_ADDR *dns_in4_get_addr (T_IN4_ADDR *dst);

#endif	/* of #ifndef RESOLVER_H */
