/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp6_echo_cli.c 1.7 2017/6/1 8:50:2 abe $
 */

/* 
 *  UDP6 ECHO 饤
 */

#include <string.h>

#if defined(TARGET_KERNEL_ASP)

#include <kernel.h>
#include <sil.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "tinet_cfg.h"

#endif	/* of #if defined(TARGET_KERNEL_ASP) */

#if defined(TARGET_KERNEL_JSP)

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#endif	/* of #if defined(TARGET_KERNEL_JSP) */

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/udp4_echo_cli.h>
#include <netapp/udp6_echo_cli.h>

#if defined(USE_UDP6_ECHO_CLI_TSK)

/* echo ФΥݡֹ */

#define ECHO_SRV_PORTNO		UINT_C(7)

/* ֳ */

#if defined(TOPPERS_S810_CLG3_85)

#define SLP_ITV		(30*SYSTIM_HZ)

#else	/* of #if defined(TOPPERS_S810_CLG3_85) */

#define SLP_ITV		(60*SYSTIM_HZ)

#endif	/* of #if defined(TOPPERS_S810_CLG3_85) */

/* ư¹ */

#if defined(UDP6_ECHO_CLI_AUTO_RUN_STR)
#else
#if 0
#define UDP6_ECHO_CLI_AUTO_RUN_STR	"fe80::211:2fff:fe8a:e8c0 - 1000"
#endif
#endif

/*
 *  ѿ
 */

bool_t udp6_echo_cli_valid;

/*
 * ѿ
 */

#define BUF_SIZE	2048

static char		udp_buf[BUF_SIZE];
static T_IPV6EP		dst;

#if defined(USE_UDP_NON_BLOCKING)

static ER_UINT		nblk_len;
static ID		nblk_tskid;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp6_echo_cli (ID cepid, FN fncd, void *p_parblk)
{
	nblk_len = *(ER_UINT*)p_parblk;
	syscall(wup_tsk(nblk_tskid));
	return E_OK;
	}

/*
 *  udp6_echo_cli -- ECHO/UDP Ф˥å (Υ֥å󥰥)
 */

static ER
udp6_echo_cli (ID cepid, T_IN6_ADDR *ipaddr, uint16_t portno, char *line)
{
	ER_UINT	error;
	SYSTIM	time;
	uint_t	len;

	dst.ipaddr = *ipaddr;
	dst.portno = portno;
	len         = strlen(line);
	get_tim(&time);
	get_tid(&nblk_tskid);
	if ((error = udp6_snd_dat(cepid, &dst, line, len, TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[UEC6:%02u SDN] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(nblk_len));
		return error;
		}
	else
		syslog(LOG_NOTICE, "[UEC6:%02u SDN] send:  %7lu,  to: %s.%d\n"
		                   "                                    msg: %s",
		                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, line);

	syscall(slp_tsk());
	get_tim(&time);
	if (nblk_len < 0) {	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UEC6:%02u CBR] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(nblk_len));
		return nblk_len;
		}

	if ((error = udp6_rcv_dat(cepid, &dst, udp_buf, sizeof(udp_buf), TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[UEC6:%02u RVN] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(nblk_len));
		return error;
		}

	syscall(slp_tsk());
	get_tim(&time);
	if (nblk_len < 0) {	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UEC6:%02u RVN] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(nblk_len));
		return nblk_len;
		}
	else {
		udp_buf[nblk_len] = '\0';
		get_tim(&time);
		syslog(LOG_NOTICE, "[UEC6:%02u RVN] recv:  %7lu,from: %s.%d\n"
		                   "                                    msg: %s",
		                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, udp_buf);
		nblk_len = E_OK;
		}

	return nblk_len;
	}

#else	/* of #if defined(USE_UDP_NON_BLOCKING) */

#if defined(USE_UDP_CALL_BACK)

/*
 *  Хåؿ
 */

ER
callback_udp6_echo_cli (ID cepid, FN fncd, void *p_parblk)
{
	SYSTIM	time;
	ER_UINT	len;

	get_tim(&time);
	if ((len = udp6_rcv_dat(cepid, &dst, udp_buf, sizeof(udp_buf), TMO_FEVR)) >= 0) {
		*(udp_buf + len) = '\0';
		syslog(LOG_NOTICE, "[UEC6:%02u RVC)] recv:  %7lu,from: %s.%d\n"
		                   "                                  msg: %s",
		                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, udp_buf);
		}
	else
		syslog(LOG_NOTICE, "[UEC6:%02u RVC] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(len));

	return E_OK;
	}

/*
 *  udp6_echo_cli -- ECHO/UDP Ф˥å (Хåؿ)
 */

static ER
udp6_echo_cli (ID cepid, T_IN6_ADDR *ipaddr, uint16_t portno, char *line)
{
	SYSTIM	time;
	ER_UINT	len;

	dst.ipaddr = *ipaddr;
	dst.portno = portno;
	len        = strlen(line);
	get_tim(&time);
	syslog(LOG_NOTICE, "[UEC6:%02u SDC)] send:  %7lu,  to: %s.%d\n"
		           "                                  msg: %s",
	                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, line);
	if ((len = udp6_snd_dat(cepid, &dst, line, len, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[UEC6:%02u SDC] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(len));

	return E_OK;
	}

#else	/* of #if defined(USE_UDP_CALL_BACK) */

/*
 *  udp6_echo_cli -- ECHO/UDP Ф˥å (Хåؿ̤)
 */

static ER
udp6_echo_cli (ID cepid, T_IN6_ADDR *ipaddr, uint16_t portno, char *line)
{
	SYSTIM	time;
	ER_UINT	len;

	dst.ipaddr = *ipaddr;
	dst.portno = portno;
	len         = strlen(line);
	get_tim(&time);
	syslog(LOG_NOTICE, "[UEC6:%02u SND] send:  %7lu,  to: %s.%d\n"
		           "                              msg: %s",
	                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, line);
	if ((len = udp6_snd_dat(cepid, &dst, line, len, TMO_FEVR)) < 0) {
		syslog(LOG_NOTICE, "[UEC6:%02u SND] error: %7lu,%s",
		                   cepid, time / SYSTIM_HZ, itron_strerror(len));
		return len;
		}

	if ((len = udp6_rcv_dat(cepid, &dst, udp_buf, sizeof(udp_buf), 10*1000)) >= 0) {
		*(udp_buf + len) = '\0';
		get_tim(&time);
		syslog(LOG_NOTICE, "[UEC6:%02u RCV] recv:  %7lu,from: %s.%d\n"
		                   "                              msg: %s",
		                   cepid, time / SYSTIM_HZ, ipv62str(NULL, &dst.ipaddr), dst.portno, udp_buf);
		return E_OK;
		}
	else {
		get_tim(&time);
		syslog(LOG_NOTICE, "[UEC6:%02u RCV] error: %7lu,%s",
		       cepid, time / SYSTIM_HZ, itron_strerror(len));
		return len;
		}
	}

#endif	/* of #if defined(USE_UDP_CALL_BACK) */

#endif	/* of #if defined(USE_UDP_NON_BLOCKING) */

/*
 *  getcomd -- ޥɤ롣
 */

#if defined(UDP6_ECHO_CLI_AUTO_RUN_STR)

static char *
getcomd (ID cepid, bool_t retry)
{
	ER		error;
	char		*line = NULL;
	static char	auto_run_str[] = UDP6_ECHO_CLI_AUTO_RUN_STR;
	static int_t	count = 0;

	if (retry || count == 0) {
		line = auto_run_str;
		dly_tsk(6 * 1000);
		}
	else {
		while ((error = rcv_dtq(DTQ_UDP6_ECHO_CLI, (intptr_t*)&line)) != E_OK) {
			syslog(LOG_NOTICE, "[UEC6:%02u TSK] error:%s", cepid, itron_strerror(error));
			dly_tsk(SLP_ITV);
			}
		}

	count ++;
	return line;
	}

#else	/* of #if defined(UDP6_ECHO_CLI_AUTO_RUN_STR) */

static char *
getcomd (ID cepid, bool_t retry)
{
	ER	error;
	char	*line = NULL;

	while ((error = rcv_dtq(DTQ_UDP6_ECHO_CLI, (intptr_t*)&line)) != E_OK) {
		syslog(LOG_NOTICE, "[UEC6:%02u TSK] error:%s", cepid, itron_strerror(error));
		dly_tsk(SLP_ITV);
		}
	return line;
	}

#endif	/* of #if defined(UDP6_ECHO_CLI_AUTO_RUN_STR) */

#define MESSAGE_FORMAT	"MSG 1000000"

/*
 *  UDP6 ECHO 饤
 */

void
udp6_echo_cli_task (intptr_t exinf)
{
	static char msg[sizeof(MESSAGE_FORMAT)] = MESSAGE_FORMAT;

	ID		tskid, cepid;
	ER		error = E_OK;
	SYSTIM		time;
	T_IN6_ADDR	addr;
	char		*line, *p;
	int_t		rep;
	uint32_t	count, msgno;
	bool_t		retry = false;
	uint16_t	portno = ECHO_SRV_PORTNO;

#if defined(USE_UDP_EXTENTIONS)
	T_UDP6_CCEP	ccep;
#endif

	dly_tsk(10*1000);
	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP6 ECHO CLI:%d,%d] started.", tskid, (ID)exinf);
	while (true) {
		line = skip_blanks(getcomd((ID)exinf, retry));

		if ((line = lookup_ipaddr(&addr, line, API_PROTO_IPV6)) == NULL) {
			syslog(LOG_NOTICE, "[UEC6:%02u TSK] sleep %d.%03u[s], unknown host.",
			       (ID)exinf, SLP_ITV / SYSTIM_HZ, SLP_ITV % SYSTIM_HZ);
			dly_tsk(SLP_ITV);
			syslog(LOG_NOTICE, "[UEC6:%02u TSK] resume.", (ID)exinf);
			retry = true;
			continue;
			}

		line = skip_blanks(line);
		if ('0' <= *line && *line <= '9') {	/* Port No */
			line = get_int(&rep, line);
			portno = (uint16_t)rep;
			}
		else if (*line == '-')
			line ++;

#if defined(USE_UDP_EXTENTIONS)

		ccep.cepatr = UINT_C(0);
		ccep.myaddr.portno = UDP_PORTANY;
		memcpy(&ccep.myaddr.ipaddr, &ipv6_addrany, sizeof(T_IN6_ADDR));

#ifdef USE_UDP_NON_BLOCKING
		ccep.callback = (FP)callback_nblk_udp6_echo_cli;
#else
		ccep.callback = NULL;
#endif

		if ((error = alloc_udp6_cep(&cepid, tskid, &ccep)) != E_OK) {
			syslog(LOG_NOTICE, "[UEC6:%02u TSK] CEP create error:%s", cepid, itron_strerror(error));
			continue;
			}

#else/* of #ifdef USE_UDP_EXTENTIONS */

		cepid = (ID)exinf;

#endif	/* of #if defined(USE_UDP_EXTENTIONS) */

		line = skip_blanks(line);
		if ('0' <= *line && *line <= '9') {				/* Repeat */
			line = get_int(&rep, line);
#if 0
			if (rep > 1000000)
				rep = 1000000;
#endif
			udp6_echo_cli_valid = true;
			count = 0;
			while (rep == 0 || count < rep) {
				if (!udp6_echo_cli_valid) {
					syslog(LOG_NOTICE, "[UEC6:%02u TSK] canceled.", cepid);
					break;
					}
					
				count ++;
				p = &msg[sizeof(MESSAGE_FORMAT)] - 1;
				for (msgno = count; msgno > 0; msgno /= 10)
					*(-- p) = msgno % 10 + '0';
				while (*(p - 2) != 'G')
					*(-- p) = ' ';

				if ((error = udp6_echo_cli(cepid, &addr, portno, msg)) != E_OK)
					dly_tsk(30 * SYSTIM_HZ);

				dly_tsk(25 * SYSTIM_HZ + netapp_rand() % (10 * SYSTIM_HZ));
				}
			}

		else								/* Single Message */

			error = udp6_echo_cli(cepid, &addr, portno, line);

		if (error != E_OK) {
			get_tim(&time);
			syslog(LOG_NOTICE, "[UEC6:%02u SND] error: %7lu,%s",
			                   cepid, time / SYSTIM_HZ, itron_strerror(error));
			}

#if defined(USE_UDP_EXTENTIONS)

		if ((error = free_udp6_cep(cepid, !(error == E_NOEXS || error == E_DLT))) != E_OK)
			syslog(LOG_NOTICE, "[UEC6:%02u TSK] CEP delete error:%s", cepid, itron_strerror(error));

#endif	/* of #if defined(USE_UDP_EXTENTIONS) */

		}
	}

#endif	/* of #if defined(USE_UDP6_ECHO_CLI_TSK) */
