/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in.h 1.7 2017/6/1 8:49:33 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1990, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)in.h	8.3 (Berkeley) 1/3/94
 * $FreeBSD: src/sys/netinet/in.h,v 1.38.2.3 1999/08/29 16:29:34 peter Exp $
 */
 
#ifndef _IN_H_
#define _IN_H_

#include <tinet_kernel_defs.h>

#include <netinet/in4.h>
#include <netinet6/in6.h>

/*
 *  TINET ΥС
 */

#define TINET_PRVER		UINT_C(0x1070)	/* TINET ΥСֹ */

/*
 *  󥿡ͥåȥƥRFC790 
 */

/*
 *  ץȥ (RFC1700)
 */

#define IPPROTO_IP		UINT_C(0)	/* IP Υߡ				*/
#define IPPROTO_HOPOPTS		UINT_C(0)	/* IPv6  (Hop-by-Hop) ץ	*/
#define IPPROTO_ICMP		UINT_C(1)	/* ICMP					*/
#define IPPROTO_TCP		UINT_C(6)	/* TCP					*/
#define IPPROTO_UDP		UINT_C(17)	/* UDP					*/
#define IPPROTO_IPV6		UINT_C(41)	/* IPv6					*/
#define IPPROTO_ROUTING		UINT_C(43)	/* ϩ楪ץ			*/
#define IPPROTO_FRAGMENT	UINT_C(44)	/* Ҳץ			*/
#define IPPROTO_RSVP		UINT_C(46)	/* RSVP					*/
#define IPPROTO_ESP		UINT_C(50)	/* IPv6 Ź沽ץ		*/
#define IPPROTO_AH		UINT_C(51)	/* IPv6 ǧڥץ			*/
#define IPPROTO_ICMPV6		UINT_C(58)	/* ICMPv6				*/
#define IPPROTO_NONE		UINT_C(59)	/* IPv6 إå̵			*/
#define IPPROTO_DSTOPTS		UINT_C(60)	/* IPv6 ץ			*/
#define IPPROTO_IPCOMP		UINT_C(108)	/* ڥɰ			*/
#define IPPROTO_DONE		UINT_C(257)	/* IPv6 Ǿ̥ץȥϽλ	*/

/*
 *  ݡȤĹ
 */

#define PORT_NUM_LEN		2

/*
 *  ݡֹ
 */

#define TCP_PORTANY			UINT_C(0x0000)	/* ITRON TCP/IP ɸ	*/
#define UDP_PORTANY			UINT_C(0x0000)	/* ITRON TCP/IP ɸ	*/

#define TCP_PORT_LAST_WELL_KNOWN	UINT_C(1023)	/* Well Known λֹ	*/
#define TCP_PORT_FIRST_AUTO		UINT_C(1024)	/* ưƳֹ	*/
#define TCP_PORT_LAST_AUTO		UINT_C(4999)	/* ưƽλֹ	*/

#define UDP_PORT_LAST_WELL_KNOWN	UINT_C(1023)	/* Well Known λֹ	*/
#define UDP_PORT_FIRST_AUTO		UINT_C(1024)	/* ưƳֹ	*/
#define UDP_PORT_LAST_AUTO		UINT_C(4999)	/* ưƽλֹ	*/

/*
 *  API IPץȥλ
 */

#define API_PROTO_IPVn			'n'
#define API_PROTO_IPV6			'6'
#define API_PROTO_IPV4			'4'

/*
 *  ưŪ TCP/IPv6 ̿ü
 */

#define T_TCP6_CCEP			T_TCP_CCEP

/*
 *  Хȥؿ
 *
 *    tinet/net/net.h ǤХȥԤäƤ뤬
 *    tinet/net/net.h 򥤥󥯥롼ɤʤ
 *    ץꥱץѤ
 *    åȰ¸ʤХȥؿ롣
 */

#if defined(_NET_CFG_BYTE_ORDER)

/*  tinet/net/net.h 򥤥󥯥롼ɤƤ롣*/

#else	/* of #if defined(_NET_CFG_BYTE_ORDER) */

extern uint16_t ntohs (uint16_t net);
extern uint16_t htons (uint16_t host);
extern uint32_t ntohl (uint32_t net);
extern uint32_t htonl (uint32_t host);

#define NTOHS(n)	(n=ntohs(n))
#define HTONS(h)	(h=htons(h))
#define NTOHL(n)	(n=ntohl(n))
#define HTONL(h)	(h=htonl(h))

#endif	/* of #if defined(_NET_CFG_BYTE_ORDER) */

/*
 *  TINET ȼ API
 */

extern const char *in_strtfn (FN fncd);

#endif	/* of #ifndef _IN_H_ */
