/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in4_subr.c 1.7 2017/6/1 8:49:22 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>

#ifdef TARGET_KERNEL_ASP

#include <kernel.h>
#include <sil.h>
#include "kernel_cfg.h"

#endif	/* of #ifdef TARGET_KERNEL_ASP */

#ifdef TARGET_KERNEL_JSP

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#endif	/* of #ifdef TARGET_KERNEL_JSP */

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
//#include <net/ppp_ipcp.h>
#include <net/net.h>
#include <net/net_endian.h>
#include <net/net_buf.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>

#include <net/if_var.h>

#if defined(_IP4_CFG)

#if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in_rtinit -- 롼ƥɽ롣
 */

void
in_rtinit (void)
{
	int_t ix;

	for (ix = 0; ix < NUM_IN4_STATIC_ROUTE_ENTRY; ix ++)
		routing4_tbl[ix].flags = IN_RTF_DEFINED;

	for ( ; ix < NUM_IN4_ROUTE_ENTRY; ix ++)
		routing4_tbl[ix].flags = 0;
	}

/*
 *  in_rtnewentry -- ȥ롣
 */

T_IN4_RTENTRY *
in_rtnewentry (uint8_t flags, uint32_t tmo)
{
	SYSTIM		now;
	T_IN4_RTENTRY	*rt, *frt = NULL;
	int_t		ix;

	/* ȥõ*/
	for (ix = NUM_IN4_STATIC_ROUTE_ENTRY; ix < NUM_IN4_ROUTE_ENTRY; ix ++) {
		rt = &routing4_tbl[ix];
		if ((routing4_tbl[ix].flags & IN_RTF_DEFINED) == 0) {
			frt = rt;
			break;
			}
		}

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	if (frt == NULL) {
		/* ʤС֤ͭäȤûȥˤ롣*/
		T_IN4_RTENTRY	*srt = NULL;
		int_t		diff, sdiff = INT_MAX;

		syscall(wai_sem(SEM_IN4_ROUTING_TBL));
		for (ix = NUM_IN4_STATIC_ROUTE_ENTRY; ix < NUM_IN4_ROUTE_ENTRY; ix ++) {
			rt = &routing4_tbl[ix];
			diff = (int_t)(rt->expire - now);
			if (diff <= 0) {	/* rt->expire <= now */
				/* ˡ֤ͭ᤮Ƥ롣*/
				frt = rt;
				break;
				}
			else if (diff < sdiff) {
				srt = rt;
				sdiff = diff;
				}
			}
		if (frt == NULL)
			frt = srt;
		frt->flags = 0;
		syscall(sig_sem(SEM_IN4_ROUTING_TBL));
		}

	frt->flags  = (uint8_t)(flags | IN_RTF_DEFINED);
	frt->expire = now + tmo / SYSTIM_HZ;
	return frt;
	}

/*
 *  in_rttimer -- 롼ƥɽδޡ
 */

void
in_rttimer (void)
{
	SYSTIM	now;
	int_t	ix;

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	syscall(wai_sem(SEM_IN4_ROUTING_TBL));
	for (ix = NUM_IN4_STATIC_ROUTE_ENTRY; ix < NUM_IN4_ROUTE_ENTRY; ix ++)
		if ((routing4_tbl[ix].flags & IN_RTF_DEFINED) &&
		    (int_t)(routing4_tbl[ix].expire - now) <= 0)
			routing4_tbl[ix].flags = 0;
	syscall(sig_sem(SEM_IN4_ROUTING_TBL));
	}

#endif	/* of #if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0 */

/*
 *  in4_get_maxnum_ifaddr -- 󥿥եǽʺ祢ɥ쥹֤
 */

uint_t
in4_get_maxnum_ifaddr (void)
{
	return 1;
	}

/*
 *  in4_get_ifaddr -- 󥿥եꤵƤ륢ɥ쥹֤
 */

const T_IN4_ADDR *
in4_get_ifaddr (int_t index)
{
	T_IFNET		*ifp = IF_GET_IFNET();

	return &ifp->in4_ifaddr.addr;
	}

/*
 *  in4_set_header -- IPv4 إåꤹ롣
 */

ER
in4_set_header (T_NET_BUF *nbuf, uint_t len,
                T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr, uint8_t proto, uint8_t ttl)
{
	T_IP4_HDR	*ip4h = GET_IP4_HDR(nbuf);
	T_IFNET		*ifp = IF_GET_IFNET();

	/* IP إåꤹ롣*/
	ip4h->vhl	= IP4_MAKE_VHL(IPV4_VERSION, IP4_HDR_SIZE >> 2);
	ip4h->len	= htons(IP4_HDR_SIZE + len);
	ip4h->proto	= proto;
	ip4h->ttl	= ttl;
	ip4h->type	= 0;
	ip4h->id	= ip4h->flg_off = ip4h->sum = 0;

	/* IP ɥ쥹ꤹ롣*/
	ip4h->dst	= htonl(*dstaddr);

	if (srcaddr == NULL || *srcaddr == IPV4_ADDRANY)
		ip4h->src = htonl(ifp->in4_ifaddr.addr);
	else
		ip4h->src = htonl(*srcaddr);

	return E_OK;
	}

/*
 *  in4_get_datagram -- IPv4 ǡإåꤹ롣
 */

ER
in4_get_datagram (T_NET_BUF **nbuf, uint_t len, uint_t maxlen,
                  T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr,
                  uint8_t proto, uint8_t ttl, ATR nbatr, TMO tmout)
{
	ER	error;
	uint_t	align;

	/* ǡĹ 4 ƥåȶĴ롣*/
	align = (len + 3) >> 2 << 2;

	/* ͥåȥХåե롣*/
	if ((error = tget_net_buf_ex(nbuf, (uint_t)(IF_IP4_HDR_SIZE + align),
	                                   (uint_t)(IF_IP4_HDR_SIZE + maxlen), nbatr, tmout)) != E_OK)
		return error;

	/*
	 *  礭ʥΥͥåȥХåեΤĹĴ롣
	 *  꾮ʥΥͥåȥХåեγϡɥХåե
	 *  ʥԡǽǻѤ졢ºݤޤǡǡϷǤʤ
	 */
	if ((nbatr & NBA_SEARCH_ASCENT) != 0)
		(*nbuf)->len = (uint16_t)(IF_IP4_HDR_SIZE + len);

	/* IP إåꤹ롣*/
	if ((error = in4_set_header(*nbuf, len, dstaddr, srcaddr, proto, ttl)) != E_OK)
		return error;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((GET_IP4_SDU(*nbuf) + len), 0, (size_t)(align - len));

	return E_OK;
	}

/*
 *  in4_cksum -- IPv4 Υȥ󥹥ݡإإåΥå׻롣
 *
 *  : ͤϥͥåȥХȥ
 */

uint16_t
in4_cksum (T_NET_BUF *nbuf, uint8_t proto, uint_t off, uint_t len)
{
	uint32_t	sum;
	uint_t		align;

	/* 4 ƥåȶΥǡĹ */
	align = (len + 3) >> 2 << 2;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((uint8_t*)nbuf->buf + off + len, 0, (size_t)(align - len));

	sum = in_cksum_sum(nbuf->buf + off, align)
	    + in_cksum_sum(&GET_IP4_HDR(nbuf)->src, sizeof(T_IN4_ADDR) * 2)
	    + len + proto;
	sum = in_cksum_carry(sum);

	return (uint16_t)(~htons((uint16_t)sum));
	}

/*
 *  in_cksum -- å׻ؿIPv4ICMPv4 
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 *
 *        ͤϥͥåȥХȥ
 */

uint16_t
in_cksum (void *data, uint_t len /*ƥåñ*/)
{
	uint16_t	sum;

	sum = (uint16_t)in_cksum_carry(in_cksum_sum(data, len));
	return (uint16_t)(~htons(sum));
	}

/*
 *  in4_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */

bool_t
in4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr)
{
	if (*myaddr == IPV4_ADDRANY)
		return ntohl(*dstaddr) == IF_GET_IFNET()->in4_ifaddr.addr;
	else
		return ntohl(*dstaddr) == *myaddr;
	}

/*
 *  inn4_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */

bool_t
inn4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *nbuf)
{
	T_IP4_HDR	*iph;

	iph  = GET_IP4_HDR(nbuf);
	if (*myaddr == IPV4_ADDRANY)
		return ntohl(iph->dst) == IF_GET_IFNET()->in4_ifaddr.addr;
	else
		return ntohl(iph->dst) == *myaddr;
	}

/*
 * in4_addrwithifp -- 襢ɥ쥹ˤդ路ɥ쥹
 *                   ͥåȥ󥿥եõ롣
 *                   in6_addrwithifp 򥷥ߥ졼Ȥǡ
 *                   顼֤ȤϤʤ
 */

T_IN4_ADDR *
in4_addrwithifp (T_IFNET *ifp, T_IN4_ADDR *src, T_IN4_ADDR *dst)
{
	*src = ifp->in4_ifaddr.addr;
	return src;
	}

/*
 *  in4_add_ifaddr -- 󥿥ե IPv4 ɥ쥹ꤹ롣
 */

ER
in4_add_ifaddr (T_IN4_ADDR addr, T_IN4_ADDR mask)
{
	T_IFNET	*ifp = IF_GET_IFNET();

	ifp->in4_ifaddr.addr = addr;
	ifp->in4_ifaddr.mask = mask;
	return E_OK;
	}

#if NUM_IN4_ROUTE_ENTRY > 0

/*
 *  in4_add_route -- ϩɽ˥ȥꤹ롣
 */

ER
in4_add_route (int_t index, T_IN4_ADDR target, T_IN4_ADDR mask, T_IN4_ADDR gateway)
{

	if (0 <= index && index < NUM_IN4_STATIC_ROUTE_ENTRY) {
		routing4_tbl[index].target  = target;
		routing4_tbl[index].mask    = mask;
		routing4_tbl[index].gateway = gateway;
		return E_OK;
		}
	else
		return E_PAR;
	}

#endif	/* of #if NUM_IN4_ROUTE_ENTRY > 0 */

/*
 *  in4_rtalloc -- 롼ƥɽõ롣
 */

T_IN4_ADDR
in4_rtalloc (T_IN4_ADDR dst)
{
	int_t ix;

	for (ix = NUM_IN4_ROUTE_ENTRY; ix --; )
		if ((routing4_tbl[ix].flags & IN_RTF_DEFINED) &&
		    (dst & routing4_tbl[ix].mask) == routing4_tbl[ix].target) {
			if (routing4_tbl[ix].gateway == 0)
				return dst;
			else {
				return routing4_tbl[ix].gateway;
				}
			}
	return dst;
	}

#if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in4_rtredirect -- 롼ƥɽ˥ȥϿ롣
 *
 *    :  tmo ñ̤ [ms]
 */

void
in4_rtredirect (T_IN4_ADDR gateway, T_IN4_ADDR target, uint8_t flags, uint32_t tmo)
{
	T_IN4_RTENTRY	*frt;

	frt = in_rtnewentry(flags, tmo);
	frt->gateway    = gateway;
	frt->target     = target;
	frt->mask       = 0xffffffff;
	}

#endif	/* of #if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0 */

/*
 *  in4_timer -- IPv4 ̥ޡ
 *
 *    1üǵư롣
 */

static void
in4_timer (void *ignore)
{
#if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0

	in_rttimer();

#endif	/* of #if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0 */

#ifdef IP4_CFG_FRAGMENT

	ip_frag_timer();

#endif	/* of #ifdef IP4_CFG_FRAGMENT */

	timeout(in4_timer, NULL, IN_TIMER_TMO);
	}

/*
 *  in4_init -- IPv4 ̵ǽ롣
 */

void
in4_init (void)
{
#if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0

	in_rtinit();

#endif	/* of #if NUM_IN4_REDIRECT_ROUTE_ENTRY > 0 */

	timeout(in4_timer, NULL, IN_TIMER_TMO);
	}

#endif	/* of #if defined(_IP4_CFG) */
