/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in4_var.h 1.7 2017/6/1 8:49:35 abe $
 */

/*
 * Copyright (c) 1985, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)in_var.h	8.2 (Berkeley) 1/9/95
 * $FreeBSD: src/sys/netinet/in_var.h,v 1.29.2.1 1999/08/29 16:29:38 peter Exp $
 */
 
#ifndef _IN4_VAR_H_
#define _IN4_VAR_H_

#ifndef _MACRO_ONLY

/*
 *  󥿥եɥ쥹¤
 */

typedef struct t_in4_ifaddr {
	T_IN4_ADDR		addr;		/* IPv4 ɥ쥹	*/
	T_IN4_ADDR		mask;		/* ֥ͥåȥޥ	*/
	} T_IN4_IFADDR;

/*
 *  롼ƥɽȥ깽¤
 */

typedef struct t_in4_rtentry {
	T_IN4_ADDR	target;		/* ɸͥåȥɥ쥹			*/
	T_IN4_ADDR	mask;		/* ɸͥåȥɥ쥹Υ֥ͥåȥޥ	*/
	T_IN4_ADDR	gateway;	/* ȥ IP ɥ쥹			*/
	uint32_t	expire;		/* ֤ͭڤ [s]			*/
	uint8_t		flags;		/* ե饰					*/
	} T_IN4_RTENTRY;
/*
 *  TINET 1.1 ȤθߴΤ
 *
 *  TINET 1.5 ȤθߴΤ̵ˤ
 */

#if 0
#ifdef NUM_ROUTE_ENTRY

#define NUM_IN4_ROUTE_ENTRY		NUM_ROUTE_ENTRY
#define NUM_IN4_STATIC_ROUTE_ENTRY	NUM_ROUTE_ENTRY
#define NUM_IN4_REDIRECT_ROUTE_ENTRY	0
#define T_RT_ENTRY			T_IN4_RTENTRY

#endif	/* of #ifdef NUM_ROUTE_ENTRY */
#endif

/*
 *  롼ƥɽ
 */

#ifdef SUPPORT_INET4

extern T_IN4_RTENTRY routing4_tbl[];

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  
 */

#ifndef T_NET_BUF_DEFINED
typedef struct t_net_buf T_NET_BUF;
#define T_NET_BUF_DEFINED
#endif

#ifndef T_IFNET_DEFINED
typedef struct t_ifnet T_IFNET;
#define T_IFNET_DEFINED
#endif

/*
 *  ؿߥ졼ޥ
 */

#define IN4_COPY_TO_HOST(dst,nbuf)	(*(dst)=ntohl(GET_IP4_HDR(nbuf)->src))

/*
 *  ؿ
 */

extern void ip_input (T_NET_BUF *data);
extern ER in4_set_header (T_NET_BUF *nbuf, uint_t len,
                          T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr, uint8_t proto, uint8_t ttl);
extern ER in4_get_datagram (T_NET_BUF **nbuf, uint_t len, uint_t maxlen,
                            T_IN4_ADDR *dstaddr, T_IN4_ADDR *srcaddr,
                            uint8_t proto, uint8_t ttl, ATR nbatr, TMO tmout);
extern uint16_t in4_cksum (T_NET_BUF *nbuf, uint8_t proto, uint_t off, uint_t len);
extern T_IN4_ADDR in4_rtalloc (T_IN4_ADDR dst);
extern void in4_rtredirect (T_IN4_ADDR gateway, T_IN4_ADDR target, uint8_t flags, uint32_t tmo);
extern void in4_init (void);
extern T_IN4_ADDR *in4_addrwithifp (T_IFNET *ifp, T_IN4_ADDR *src, T_IN4_ADDR *dst);
extern const T_NET_BUF**ip_get_frag_queue (void);

/*
 *  in4_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 *
 *    : dstaddr ϡ
 *          TINET-1.2 ͥåȥХȥ
 *          TINET-1.1 ޤǤϡۥȥХȥ
 */
extern bool_t in4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_IN4_ADDR *dstaddr);
extern bool_t inn4_is_dstaddr_accept (T_IN4_ADDR *myaddr, T_NET_BUF *input);

/*
 *  in_cksum -- å׻ؿIPv4ICMPv4 
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern uint16_t in_cksum(void *data, uint_t len /*ƥåñ*/);

/*
 *  in_cksum_sum -- åι׷׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern uint32_t in_cksum_sum (void *data, uint_t len /*ƥåñ*/);

/*
 *  in_cksum_carry -- åη夲׻ؿ
 *
 *  : data  4 ƥåñ̤ǥѥǥ󥰤뤳ȡ
 *        data  2 ƥåñ̤˥饤󤵤Ƥʤ
 *        㳰ȯǽ롣
 *        len   4 ƥåñ̤˥饤󤵤Ƥ뤳ȡ
 */
extern uint32_t in_cksum_carry (uint32_t sum);

#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _IN4_VAR_H_ */
