/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcp_usrreq.c 1.7 2017/6/1 8:49:26 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	From: @(#)tcp_usrreq.c	8.2 (Berkeley) 1/3/94
 * $FreeBSD: src/sys/netinet/tcp_usrreq.c,v 1.40.2.3 1999/08/29 16:29:57 peter Exp $
 */

#include <string.h>

#ifdef TARGET_KERNEL_ASP

#include <kernel.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "tinet_cfg.h"

#endif	/* of #ifdef TARGET_KERNEL_ASP */

#ifdef TARGET_KERNEL_JSP

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#endif	/* of #ifdef TARGET_KERNEL_JSP */

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_endian.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>
#include <net/net_count.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/tcp.h>
#include <netinet/tcp_var.h>
#include <netinet/tcp_fsm.h>
#include <netinet/tcp_seq.h>
#include <netinet/tcp_timer.h>

#include <net/if_var.h>

#ifdef SUPPORT_TCP

/*
 *  TINET 饤֥경ʤϡƤεǽ
 *  ֥ȥե˽Ϥ뤿ᡢޥͭˤ롣
 */

#ifndef TCP_CFG_LIBRARY

#define __tcp_cre_rep
#define __tcp_del_rep
#define __tcp_cre_cep
#define __tcp_del_cep
#define __tcp_acp_cep
#define __tcp_con_cep
#define __tcp_sht_cep
#define __tcp_cls_cep
#define __tcp_snd_dat
#define __tcp_rcv_dat
#define __tcp_snd_oob
#define __tcp_rcv_oob
#define __tcp_get_buf
#define __tcp_snd_buf
#define __tcp_rcv_buf
#define __tcp_rel_buf
#define __tcp_can_cep
#define __tcp_set_opt
#define __tcp_get_opt

#endif	/* of #ifndef TCP_CFG_LIBRARY */

/*
 *  IPv6  IPv4 ǰۤʤؿΥѥ
 */

#if defined(SUPPORT_INET6)

#define T_IPEP			T_IPV6EP
#define TCP_ACP_CEP		tcp6_acp_cep
#define TCP_CON_CEP		tcp6_con_cep
#define TCP_FIND_CEP_REP	tcp6_find_cep_rep

#if defined(SUPPORT_INET4)

#undef	T_TCP_REP
#define T_TCP_REP		T_TCP6_REP

#endif	/* of #if defined(SUPPORT_INET4) */

#define TCP_CRE_REP		tcp6_cre_rep
#define TCP_DEL_REP_BODY	tcp6_del_rep_body
#define GET_TCP_REP		GET_TCP6_REP
#define VALID_TCP_REPID		VALID_TCP6_REPID
#define T_TCPN_CREP		T_TCP6_CREP
#define API_PROTO		API_PROTO_IPV6

#include <netinet/tcpn_usrreq.c>

#undef  T_IPEP
#undef  TCP_ACP_CEP
#undef  TCP_CON_CEP
#undef	TCP_FIND_CEP_REP

#undef  TCP_CRE_REP
#undef	TCP_DEL_REP_BODY
#undef	GET_TCP_REP
#undef	VALID_TCP_REPID
#undef	T_TCPN_CREP
#undef  API_PROTO

#endif	/* of #if defined(SUPPORT_INET6) */

#if defined(SUPPORT_INET4)

#define T_IPEP			T_IPV4EP
#define TCP_ACP_CEP		tcp_acp_cep
#define TCP_CON_CEP		tcp_con_cep
#define TCP_FIND_CEP_REP	tcp4_find_cep_rep

#if defined(SUPPORT_INET6)

#undef	T_TCP_REP
#define T_TCP_REP		T_TCP4_REP

#endif	/* of #if defined(SUPPORT_INET6) */

#define TCP_CRE_REP		tcp_cre_rep
#define TCP_DEL_REP_BODY	tcp4_del_rep_body
#define GET_TCP_REP		GET_TCP4_REP
#define VALID_TCP_REPID		VALID_TCP4_REPID
#define T_TCPN_CREP		T_TCP_CREP
#define API_PROTO		API_PROTO_IPV4

#include <netinet/tcpn_usrreq.c>

#endif	/* of #if defined(SUPPORT_INET4) */

#ifdef __tcp_cls_cep

/*
 *  tcp_user_closed -- 桼Υͥγ
 */

T_TCP_CEP *
tcp_user_closed (T_TCP_CEP *cep)
{
	switch (cep->fsm_state) {

	case TCP_FSM_CLOSED:		/* 	*/
	case TCP_FSM_LISTEN:		/* ưץ	*/
		cep->fsm_state = TCP_FSM_CLOSED;
		cep = tcp_close(cep);
		break;

	case TCP_FSM_SYN_SENT:		/* ǽưץSYN Ѥ	*/
	case TCP_FSM_SYN_RECVD:		/* SYN SYN Ѥ	*/
		cep->flags |= TCP_CEP_FLG_NEED_FIN;
		break;

	case TCP_FSM_ESTABLISHED:	/* ͥߴλ	*/
		cep->fsm_state = TCP_FSM_FIN_WAIT_1;
		break;

	case TCP_FSM_CLOSE_WAIT:	/* ꤫ FIN APP νλԤ */
		cep->fsm_state = TCP_FSM_LAST_ACK;
		break;
		}

	if (cep != NULL && cep->fsm_state == TCP_FSM_FIN_WAIT_2)
		cep->timer[TCP_TIM_2MSL] = TCP_TVAL_KEEP_COUNT * TCP_TVAL_KEEP_INTERVAL;
	return cep;
	}

/*
 *  tcp_cls_cep -- ̿üΥɸൡǽ
 */

ER
tcp_cls_cep (ID cepid, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER		error = E_OK;
	FLGPTN		flag;

#ifndef TCP_CFG_NON_BLOCKING

	/* tmout  TMO_NBLK ʤ饨顼 */
	if (tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifndef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_CLS_CEP)) != E_OK)
		return error;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {				/* Υ֥å󥰥 */

		if (!IS_PTR_DEFINED(cep->callback))
			error = E_OBJ;
		else if (cep->fsm_state == TCP_FSM_CLOSED) {	/* Ǥ˥ƤȤ */

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14

			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_CLS_CEP, E_OK);
			error = E_WBLK;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

			ER	error = E_OK;

			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_CLS_CEP, (void*)&error);
			error = E_WBLK;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

			}
		else {
			/* NBLK API ǽɤꤹ롣*/
			cep->rcv_nblk_tfn = TFN_TCP_CLS_CEP;

			if ((cep = tcp_user_closed(cep)) != NULL) {	/* ͥǤ롣*/
				/* ǥȽϤݥȤ롣*/
				cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
				sig_sem(SEM_TCP_POST_OUTPUT);
				}

			/*  cep  NULL äƤϡ
			 *  ˥ͥǤƤ뤳Ȥ̣Ƥ롣
			 *  ޤξ祳ХåؿƤӽФƤ롣
			 */
			return E_WBLK;
			}
		}
	else {							/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		if ((cep = tcp_user_closed(cep)) == NULL) {	/* ͥǤ롣*/

			/*  cep  NULL äƤϡ
			 *  ˥ͥǤƤ뤳Ȥ̣Ƥ롣
			 */
			return error;
			}
		else {
			/* ǥȽϤݥȤ롣*/
			cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			/* ٥ȥե饰 CLOSED ˤʤޤԤġ*/
			error = twai_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED, TWF_ORW, &flag, tmout);
			if (error == E_OK && cep->error != E_OK)
				error = cep->error;

			if (error != E_OK) {
				if (error == E_RLWAI) {
					/* tcp_cls_cep 󥻥뤵줿ȤϡRST 롣*/
					tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una - 1, 
					            cep->rbufsz - cep->rwbuf_count, TCP_FLG_RST);
					}

				/* ޡߤ롣*/
				tcp_cancel_timers(cep);

				/* 
				 *  ̿üå
				 *  ƹ塼ΥͥåȥХåե롣
				 */
				syscall(wai_sem(cep->semid_lock));
				tcp_free_reassq(cep);
				syscall(sig_sem(cep->semid_lock));

				/* ֤̤Ѥˤ롣*/
				cep->fsm_state = TCP_FSM_CLOSED;

				/*
				 * ʲ˴طʤե饰򥯥ꥢ롣
				 * ɥХåեξʥԡǽ
				 * ưŪ̿üǽ
				 */
				cep->flags &= TCP_CEP_FLG_NOT_CLEAR;

				/* 
				 *  ̿üå
				 *  ɥХåե塼ΥͥåȥХåե롣
				 */
				cep->rwbuf_count = 0;
				syscall(wai_sem(cep->semid_lock));
				TCP_FREE_RWBUFQ(cep);
				TCP_FREE_SWBUFQ(cep);
				syscall(sig_sem(cep->semid_lock));

				syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
				}
			}

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_cls_cep */

#ifdef __tcp_sht_cep

/*
 *  tcp_sht_cep  -- ǡνλɸൡǽ
 */

ER
tcp_sht_cep (ID cepid)
{
	T_TCP_CEP	*cep;
	ER		error = E_OK;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SHT_CEP)) != E_OK)
		return error;

	/* TCP ̿üΥͥ󤬳Ω֤ǤʤХ顼 */
	if (!TCP_FSM_HAVE_ESTABLISHED(cep->fsm_state)) {
		if ((error = cep->error) == E_OK)
			error = E_OBJ;
		}

	else if ((cep = tcp_user_closed(cep)) != NULL) {		/* ͥǤ롣*/

		/* ǥȽϤݥȤ롣*/
		cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		}

	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_sht_cep */

#ifdef __tcp_snd_dat

/*
 *  tcp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
tcp_snd_dat (ID cepid, void *data, int_t len, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER_UINT		error;

#ifdef TCP_CFG_NON_BLOCKING

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* data  NULLlen < 0 tmout  TMO_NBLK ʤ饨顼 */
	if (data == NULL || len < 0 || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SND_DAT)) != E_OK)
		return error;

	/* Ǥ뤫̿üξ֤򸫤롣*/
	if ((error = tcp_can_send_more(cep, TFN_TCP_SND_DAT, tmout)) != E_OK)
		goto err_ret;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* ɥХåե˶ХХåؿƤӽФ*/
		if (!TCP_IS_SWBUF_FULL(cep)) {

		 	/* ɥХåե˥ǡ񤭹ࡣ*/
			error = TCP_WRITE_SWBUF(cep, data, (uint_t)len);

			/* ϤݥȤ롣*/
			cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			/* ХåؿƤӽФ*/
#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_SND_DAT, (void*)error);
#else
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_SND_DAT, (void*)&error);
#endif
			error = E_WBLK;
			goto err_ret;
			}
		else {
			cep->snd_data     = data;
			cep->snd_len      = len;
			cep->snd_nblk_tfn = TFN_TCP_SND_DAT;
			TCP_ALLOC_SWBUF(cep);

			return E_WBLK;
			}
		}
	else {		/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	 	/* ɥХåեΤԤġ*/
		if ((error = TCP_WAIT_SWBUF(cep, tmout)) != E_OK)
			goto err_ret;

	 	/* ɥХåե˥ǡ񤭹ࡣ*/
		if ((error = TCP_WRITE_SWBUF(cep, data, (uint_t)len)) > 0) {

			/* ǡ롣ɥХåեեΤȤ϶Ū롣*/
			if (TCP_IS_SWBUF_FULL(cep))
				cep->flags |= TCP_CEP_FLG_FORCE | TCP_CEP_FLG_FORCE_CLEAR;

			/* ϤݥȤ롣*/
			cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);
			}

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_snd_dat */

#ifdef __tcp_get_buf

/*
 *  tcp_get_buf -- ѥХåեγɸൡǽ
 */

ER_UINT
tcp_get_buf (ID cepid, void **p_buf, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER_UINT		error;

#ifdef TCP_CFG_NON_BLOCKING

	/* p_buf  NULL ʤ饨顼 */
	if (p_buf == NULL)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* p_buf  NULL tmout  TMO_NBLK ʤ饨顼 */
	if (p_buf == NULL || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_GET_BUF)) != E_OK)
		return error;

	/* Ǥ뤫̿üξ֤򸫤롣*/
	if ((error = tcp_can_send_more(cep, TFN_TCP_GET_BUF, tmout)) != E_OK)
		goto err_ret;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		if (!TCP_IS_SWBUF_FULL(cep)) {

			/* ɥХåե˶ХХåؿƤӽФ*/
			error = TCP_GET_SWBUF_ADDR(cep, p_buf);

			/* ХåؿƤӽФ*/
#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_GET_BUF, (void*)error);
#else
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_GET_BUF, (void*)&error);
#endif
			error = E_WBLK;
			goto err_ret;
			}
		else {
			cep->snd_p_buf    = p_buf;
			cep->snd_nblk_tfn = TFN_TCP_GET_BUF;
			TCP_ALLOC_SWBUF(cep);
			return E_WBLK;
			}
		}

	else {		/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	 	/* ɥХåեΤԤġ*/
		if ((error = TCP_WAIT_SWBUF(cep, tmout)) != E_OK)
			goto err_ret;

	 	/* ɥХåեζɥ쥹롣*/
		error = TCP_GET_SWBUF_ADDR(cep, p_buf);

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_get_buf */

#ifdef __tcp_snd_buf

/*
 *  tcp_snd_buf -- ХåեΥǡɸൡǽ
 */

ER
tcp_snd_buf (ID cepid, int_t len)
{
	T_TCP_CEP	*cep;
	ER		error;

	/* Ĺ len å롣*/
	if (len < 0)
		return E_PAR;

	/* Ĺlen  0 ǤС⤷ʤ롣*/
	if (len == 0)
		return E_OK;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SND_BUF)) != E_OK)
		return error;

	/* Ĺ len å롣*/
	if (len > cep->get_buf_len) {
		error = E_OBJ;
		goto err_ret;
		}

	/* Ǥ뤫CEP  FSM ֤򸫤롣*/
	if (!TCP_FSM_CAN_SEND_MORE(cep->fsm_state)) {
		if ((error = cep->error) == E_OK)
			error = E_OBJ;
		goto err_ret;
		}

	/* ɥХåեΥǡǽˤ롣*/
	TCP_SEND_SWBUF(cep, (uint_t)len);

	/* ϤݥȤ롣*/
	cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
	sig_sem(SEM_TCP_POST_OUTPUT);

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_snd_buf */

#ifdef __tcp_rcv_dat

/*
 *  tcp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
tcp_rcv_dat (ID cepid, void *data, int_t len, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER_UINT		error;

#ifdef TCP_CFG_NON_BLOCKING

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* data  NULLlen < 0 tmout  TMO_NBLK ʤ饨顼 */
	if (data == NULL || len < 0 || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_RCV_DAT)) != E_OK)
		return error;

	/* Ǥ뤫̿üξ֤򸫤롣*/
	if (tcp_can_recv_more(&error, cep, TFN_TCP_RCV_DAT, tmout) != E_OK)
		goto err_ret;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* ɥХåե˥ǡХХåؿƤӽФ*/
		if (cep->rwbuf_count > 0) {

			/* ɥХåեǡФ*/
			len = TCP_READ_RWBUF(cep, data, (uint_t)len);

			/* ХåؿƤӽФ*/
#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_RCV_DAT, (void*)(uint32_t)len);
#else
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_RCV_DAT, (void*)&len);
#endif
			error = E_WBLK;
			goto err_ret;
			}
		else {
			cep->rcv_data     = data;
			cep->rcv_len      = len;
			cep->rcv_nblk_tfn = TFN_TCP_RCV_DAT;
			return E_WBLK;
			}
		}
	else {		/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/* ɥХåե˥ǡʤСϤޤԤġ*/
		if ((error = tcp_wait_rwbuf(cep, tmout)) != E_OK)
			goto err_ret;

		/* ɥХåեǡФ*/
		error = TCP_READ_RWBUF(cep, data, (uint_t)len);

		/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
		cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_rcv_dat */

#ifdef __tcp_rcv_buf

/*
 *  tcp_rcv_buf -- ǡäХåեγɸൡǽ
 */

ER_UINT
tcp_rcv_buf (ID cepid, void **p_buf, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER_UINT		error;

#ifdef TCP_CFG_NON_BLOCKING

	/* p_buf  NULL ʤ饨顼 */
	if (p_buf == NULL)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* p_buf  NULL tmout  TMO_NBLK ʤ饨顼 */
	if (p_buf == NULL || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_RCV_BUF)) != E_OK)
		return error;

	/* Ǥ뤫̿üξ֤򸫤롣*/
	if (tcp_can_recv_more(&error, cep, TFN_TCP_RCV_DAT, tmout) != E_OK)
		goto err_ret;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* ɥХåե˥ǡХХåؿƤӽФ*/
		if (cep->rwbuf_count > 0) {

		 	/* ɥХåեζɥ쥹롣*/
			error = TCP_GET_RWBUF_ADDR(cep, p_buf);

			/* ХåؿƤӽФ*/
#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_RCV_BUF, (void*)error);
#else
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_RCV_BUF, (void*)&error);
#endif
			error = E_WBLK;
			goto err_ret;
			}
		else {
			cep->rcv_p_buf    = p_buf;
			cep->rcv_nblk_tfn = TFN_TCP_RCV_BUF;
			return E_WBLK;
			}
		}
	else {		/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/* ɥХåե˥ǡʤСϤޤԤġ*/
		if ((error = tcp_wait_rwbuf(cep, tmout)) != E_OK) {
			cep->rwbuf_count = 0;
			goto err_ret;
			}

	 	/* ɥХåեΥɥ쥹롣*/
		error = TCP_GET_RWBUF_ADDR(cep, p_buf);

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_rcv_buf */

#ifdef __tcp_rel_buf

/*
 *  tcp_rel_buf -- ѥХåեβɸൡǽ
 */

ER
tcp_rel_buf (ID cepid, int_t len)
{
	T_TCP_CEP	*cep;
	ER		error;

	/* Ĺ len å롣*/
	if (len < 0)
		return E_PAR;

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_REL_BUF)) != E_OK)
		return error;

	/* Ĺ len å롣*/
	if (len > cep->rcv_buf_len) {
		error = E_OBJ;
		goto err_ret;
		}

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/* ɥХåեƥåȤ롣*/
	TCP_DROP_RWBUF(cep, (uint_t)len);

	/* tcp_rcv_buf γĹꥻåȤ롣*/
	cep->rcv_buf_len = 0;

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	/* ˥ɥѤäȤΤ餻뤿ϤݥȤ롣*/
	cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
	sig_sem(SEM_TCP_POST_OUTPUT);

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_rel_buf */

#ifdef __tcp_can_cep

/*
 *  tcp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
tcp_can_snd (T_TCP_CEP *cep, FN fncd)
{
	ER	error = E_OK;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 *  snd_tskid  TA_NULL ʤ顢
	 *  ڥǥ󥰤ƤʤΤǥ顼
	 */
	if (cep->snd_tskid == TA_NULL)
		error = EV_NOPND;

	/* ڥǥ API ǽɤȰפʤХ顼 */
	else if (fncd != TFN_TCP_ALL && fncd != cep->snd_tfn)
		error = E_OBJ;

	/* 򥭥󥻥뤹롣*/
	else {

		/* ƹ塼ΥͥåȥХåե롣*/
		tcp_free_reassq(cep);

		/* ɥХåե塼ΥͥåȥХåե롣*/
		cep->rwbuf_count = 0;
		TCP_FREE_RWBUFQ(cep);

		/* ɥХåե塼ΥͥåȥХåե롣*/
		TCP_FREE_SWBUFQ(cep);

#ifdef TCP_CFG_NON_BLOCKING

		if (cep->snd_nblk_tfn != TFN_TCP_UNDEF) {	/* Υ֥å󥰥 */

			switch (cep->snd_nblk_tfn) {

			case TFN_TCP_CON_CEP:
				/*
				 *  ̿üո
				 *  ٥ȥե饰򥯥ꤹ롣
				 */
				cep->rep = NULL;

#if defined(_IP6_CFG) && defined(_IP4_CFG)
				cep->rep4 = NULL;
#endif

				cep->fsm_state = TCP_FSM_CLOSED;
				syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
				break;

			case TFN_TCP_SND_DAT:
			case TFN_TCP_GET_BUF:
			case TFN_TCP_SND_OOB:
				break;
				}

			if (IS_PTR_DEFINED(cep->callback)) {

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14

				(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (void*)E_RLWAI);

#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

				ER	error = E_RLWAI;

				(*cep->callback)(GET_TCP_CEPID(cep), cep->snd_nblk_tfn, (void*)&error);

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

				}
			else
				error = E_OBJ;
			cep->snd_nblk_tfn = TFN_TCP_UNDEF;
			}
		else

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

			error = rel_wai(cep->snd_tskid);

		cep->snd_tskid = TA_NULL;
		cep->snd_tfn   = TFN_TCP_UNDEF;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
tcp_can_rcv (T_TCP_CEP *cep, FN fncd)
{
	ER	error = E_OK;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 *  rcv_tskid  TA_NULL ʤ顢
	 *  ڥǥ󥰤ƤʤΤǥ顼
	 */
	if (cep->rcv_tskid == TA_NULL)
		error = EV_NOPND;

	/* ڥǥ API ǽɤȰפʤХ顼 */
	else if (fncd != TFN_TCP_ALL && fncd != cep->rcv_tfn)
		error = E_OBJ;

	/* 򥭥󥻥뤹롣*/
	else {

		/* ƹ塼ΥͥåȥХåե롣*/
		tcp_free_reassq(cep);

		/* ɥХåե塼ΥͥåȥХåե롣*/
		cep->rwbuf_count = 0;
		TCP_FREE_RWBUFQ(cep);

		/* ɥХåե塼ΥͥåȥХåե롣*/
		TCP_FREE_SWBUFQ(cep);

#ifdef TCP_CFG_NON_BLOCKING

		if (cep->rcv_nblk_tfn != TFN_TCP_UNDEF) {	/* Υ֥å󥰥 */

			switch (cep->rcv_nblk_tfn) {

			case TFN_TCP_ACP_CEP:
				/*
				 *  ̿üո
				 *  ٥ȥե饰򥯥ꤹ롣
				 */
				cep->rep = NULL;

#if defined(_IP6_CFG) && defined(_IP4_CFG)
				cep->rep4 = NULL;
#endif

				cep->fsm_state = TCP_FSM_CLOSED;
				syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
				break;

			case TFN_TCP_RCV_DAT:
			case TFN_TCP_RCV_BUF:
				break;

			case TFN_TCP_CLS_CEP:
				cep->fsm_state = TCP_FSM_CLOSED;
				tcp_respond(NULL, cep, cep->rcv_nxt, cep->snd_una - 1,
				            cep->rbufsz - cep->rwbuf_count, TCP_FLG_RST);
				syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
				break;
				}

			if (IS_PTR_DEFINED(cep->callback)) {

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14

				(*cep->callback)(GET_TCP_CEPID(cep), cep->rcv_nblk_tfn, (void*)E_RLWAI);

#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

				ER	error = E_RLWAI;

				(*cep->callback)(GET_TCP_CEPID(cep), cep->rcv_nblk_tfn, (void*)&error);

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

				}
			else
				error = E_OBJ;
			cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
			}
		else

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

			error = rel_wai(cep->rcv_tskid);

		cep->rcv_tskid = TA_NULL;
		cep->rcv_tfn   = TFN_TCP_UNDEF;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  tcp_can_cep -- ڥǥ󥰤ƤΥ󥻥ɸൡǽ
 */

ER
tcp_can_cep (ID cepid, FN fncd)
{
	T_TCP_CEP	*cep;
	ER		error = E_OK, snd_err, rcv_err;

	/* API ǽɤå롣*/
	if (!VALID_TFN_TCP_CAN(fncd))
		return E_PAR;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* TCP ̿üå롣*/
	if (!VALID_TCP_CEP(cep))
		return E_NOEXS;

	if (fncd == TFN_TCP_ALL) {		/* TFN_TCP_ALL ν */
		snd_err = tcp_can_snd(cep, fncd);
		rcv_err = tcp_can_rcv(cep, fncd);

		/*
		 *  snd_err  rcv_err Τɤ EV_NOPND
		 *  ʤ顢ڥǥ󥰤ƤʤΤǥ顼
		 */
		if (snd_err == EV_NOPND && rcv_err == EV_NOPND)
			error = E_OBJ;
		else {
			if (snd_err == EV_NOPND)
				snd_err = E_OK;
			if (rcv_err == EV_NOPND)
				rcv_err = E_OK;

			if (snd_err != E_OK)
				error = snd_err;
			else if (rcv_err != E_OK)
				error = rcv_err;
			}
		}

	else if (IS_TFN_TCP_RCV(fncd)) {	/* Υ󥻥 */
		if ((error = tcp_can_rcv(cep, fncd)) == EV_NOPND)
			error = E_OBJ;
		}

	else {					/* Υ󥻥 */
		if ((error = tcp_can_snd(cep, fncd)) == EV_NOPND)
			error = E_OBJ;
		}

	return error;
	}

#endif	/* of #ifdef __tcp_can_cep */

#ifdef TCP_CFG_EXTENTIONS

#ifdef __tcp_cre_cep

/*
 *  tcp_cre_cep -- TCP ̿üڳĥǽ
 */

ER
tcp_cre_cep (ID cepid, T_TCP_CCEP *pk_ccep)
{
	T_TCP_CEP	*cep;
	ER		error;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* pk_ccep  NULL ʤ饨顼 */
	if (pk_ccep == NULL)
		return E_PAR;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* TCP ̿üưŪѤǤʤХ顼 */
	if (!DYNAMIC_TCP_CEP(cep))
		return E_ID;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 * TCP ̿üå롣ѤߤǤХ顼
	 */
	if (VALID_TCP_CEP(cep))
		error = E_OBJ;
	else {

		/* TCP ̿ü򥳥ԡ롣*/
		cep->cepatr   = pk_ccep->cepatr;		/* ̿ü°			*/
		cep->sbuf     = pk_ccep->sbuf;			/* ѥɥХåե	*/
		cep->sbufsz   = pk_ccep->sbufsz;		/* ѥɥХåե	*/
		cep->rbuf     = pk_ccep->rbuf;			/* ѥɥХåե	*/
		cep->rbufsz   = pk_ccep->rbufsz;		/* ѥɥХåե	*/
		cep->callback = (void*)pk_ccep->callback;	/* Хå			*/

		/* TCP ̿üѤߤˤ롣*/
		cep->flags |= TCP_CEP_FLG_VALID;
		error = E_OK;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __tcp_cre_cep */

/*
 *  tcp_del_cep -- TCP ̿üκڳĥǽ
 */

#ifdef __tcp_del_cep

ER
tcp_del_cep (ID cepid)
{
	T_TCP_CEP	*cep;
	ER		error;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* TCP ̿üưŪѤǤʤХ顼 */
	if (!DYNAMIC_TCP_CEP(cep))
		return E_ID;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 * TCP ̿üå롣ʲξϥ顼
	 * ̤
	 * 档
	 */
	if (!VALID_TCP_CEP(cep))
		error = E_NOEXS;
	else if (cep->fsm_state != TCP_FSM_CLOSED)
		error = E_OBJ;
	else {

		/* TCP ̿ṳ̈ˤ롣*/
		cep->flags &= ~TCP_CEP_FLG_VALID;
		error = E_OK;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __tcp_del_cep */

#ifdef __tcp_snd_oob

/*
 *  tcp_snd_oob -- ۵ޥǡڳĥǽ
 */

ER_UINT
tcp_snd_oob (ID cepid, void *data, int_t len, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER_UINT		error;

#ifdef TCP_CFG_NON_BLOCKING

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* data  NULLlen < 0 tmout  TMO_NBLK ʤ饨顼 */
	if (data == NULL || len < 0 || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_SND_OOB)) != E_OK)
		return error;

	/* Ǥ뤫̿üξ֤򸫤롣*/
	if ((error = tcp_can_send_more(cep, TFN_TCP_SND_OOB, tmout)) != E_OK)
		goto err_ret;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {		/* Υ֥å󥰥 */

		/* ɥХåե˶ХХåؿƤӽФ*/
		if (!TCP_IS_SWBUF_FULL(cep)) {

		 	/* ɥХåե˥ǡ񤭹ࡣ*/
			error = TCP_WRITE_SWBUF(cep, data, (uint_t)len);

			/* ۵ޥݥ󥿤ꤹ롣*/
			cep->snd_up = cep->snd_una + cep->swbuf_count;

			/* ϤݥȤ롣*/
			cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);

			/* ХåؿƤӽФ*/
#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_SND_OOB, (void*)error);
#else
			(*cep->callback)(GET_TCP_CEPID(cep), TFN_TCP_SND_OOB, (void*)&error);
#endif
			error = E_WBLK;
			goto err_ret;
			}
		else {
			cep->snd_data     = data;
			cep->snd_len      = len;
			cep->snd_nblk_tfn = TFN_TCP_SND_OOB;
			TCP_ALLOC_SWBUF(cep);

			return E_WBLK;
			}
		}
	else {		/* Υ֥å󥰥 */

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	 	/* ɥХåեΤԤġ*/
		if ((error = TCP_WAIT_SWBUF(cep, tmout)) != E_OK)
			goto err_ret;

	 	/* ɥХåե˥ǡ񤭹ࡣ*/
		if ((error = TCP_WRITE_SWBUF(cep, data, (uint_t)len)) > 0) {

			/* ۵ޥݥ󥿤ꤹ롣*/
			cep->snd_up = cep->snd_una + cep->swbuf_count;

			/* ǡ롣ɥХåեեΤȤ϶Ū롣*/
			if (TCP_IS_SWBUF_FULL(cep))
				cep->flags |= TCP_CEP_FLG_FORCE | TCP_CEP_FLG_FORCE_CLEAR;

			/* ϤݥȤ롣*/
			cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_TCP_POST_OUTPUT);
			}

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_snd_oob */

#ifdef __tcp_rcv_oob

/*
 *  tcp_rcv_oob -- ۵ޥǡμڳĥǽ
 *
 *    : ¦ʣƥåȤΥǡƤ⡢
 *          ۵ޥݥ󥿤ؤ 1 ƥåȤΥǡΤ߼롣
 */

ER_UINT
tcp_rcv_oob (ID cepid, void *data, int_t len)
{
	T_TCP_CEP	*cep;
	uint8_t		*urg;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* data  NULL len < 0 ʤ饨顼 */
	if (data == NULL || len < 0)
		return E_PAR;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* Ǥ뤫̿üξ֤򸫤롣*/
	/* Ǥ뤫fsm_state 򸫤롣*/
	if (!TCP_FSM_CAN_RECV_MORE(cep->fsm_state))
		return E_OBJ;

	/*
	 *  ۵ޥǡΥȤ TCP إå
	 *  ꤵƤʤС۵ޥǡƤʤ
	 */
	if (cep->urg_tcph == NULL)
		return E_OBJ;

	/* len == 0 ʤХåեСե */
	if (len == 0)
		return E_BOVR;

	/* ۵ޥݥ󥿤ؤ 1 ƥåȤΥǡɤ߼롣*/
	urg = (uint8_t*)cep->urg_tcph + TCP_DATA_OFF(cep->urg_tcph->doff) + cep->urg_tcph->urp + TCP_CFG_URG_OFFSET;
	*(uint8_t*)data = *urg;

	/* ɤ߼äǡ SDU ˵ͤ롣*/
	memcpy(urg, urg + 1, cep->urg_tcph->sum - (cep->urg_tcph->urp + TCP_CFG_URG_OFFSET) - 1);

	/* tcp_rcv_oob() ƽФ줿Τ餻뤿ˡNULL ꤹ롣*/
	cep->urg_tcph = NULL;

	return 1;
	}

#endif	/* of #ifdef __tcp_rcv_oob */

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

#ifdef TCP_CFG_EXTENTIONS

#ifdef __tcp_del_rep

/*
 *  tcp_del_rep -- TCP ոκڳĥǽ
 */

#if defined(SUPPORT_INET6) && TNUM_TCP6_REPID > 0

#if defined(SUPPORT_INET4) && TNUM_TCP4_REPID > 0

ER
tcp_del_rep (ID repid)
{

	/*
	 *  TCP ո ID å롣
	 *  IPv6  TCP ոǤС
	 *  IPv6 ѤΡTCP ոκؿΡˡפƽФ
	 */
	//NET_DEBUG_TCP3("tcp_del_rep1[r=%d,n=%d,x=%d]\n",
	//               repid, TMIN_TCP6_REPID, tmax_tcp6_repid);
	//NET_DEBUG_TCP3("tcp_del_rep2[r=%d,n=%d,x=%d]\n",
	//               repid, TMIN_TCP4_REPID, tmax_tcp4_repid);
	if (VALID_TCP6_REPID(repid))
		return tcp6_del_rep_body(repid);

	/*
	 *  TCP ո ID å롣
	 *  IPv4  TCP ոǤС
	 *  IPv4 ѤΡTCP ոκؿΡˡפƽФ
	 */
	else if (VALID_TCP4_REPID(repid))
		return tcp4_del_rep_body(repid);
	else
		return E_ID;

	}

#else	/* of #if defined(SUPPORT_INET4) && TNUM_TCP4_REPID > 0 */

ER
tcp_del_rep (ID repid)
{

	/* TCP ո ID å롣*/
	if (VALID_TCP6_REPID(repid))
		return tcp6_del_rep_body(repid);
	else
		return E_ID;

	}

#endif	/* of #if defined(SUPPORT_INET4) && TNUM_TCP4_REPID > 0 */

#else	/* of #if defined(SUPPORT_INET6) && TNUM_TCP6_REPID > 0 */

ER
tcp_del_rep (ID repid)
{

	/* TCP ո ID å롣*/
	if (VALID_TCP4_REPID(repid))
		return tcp4_del_rep_body(repid);
	else
		return E_ID;

	}

#endif	/* of #if defined(SUPPORT_INET6) && TNUM_TCP6_REPID > 0 */

#endif	/* of #ifdef __tcp_del_rep */

/*
 *  tcp_set_opt -- TCP ̿üץڳĥǽ
 *
 *  : ǽ TCP ̿üץ̵ᡢE_PAR ֤롣
 */

#ifdef __tcp_set_opt

ER
tcp_set_opt (ID cepid, int_t optname, void *optval, int_t optlen)
{
	T_TCP_CEP	*cep;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* TCP ̿üå롣*/
	if (!VALID_TCP_CEP(cep))
		return E_NOEXS;

	return E_PAR;
	}

#endif	/* of #ifdef __tcp_set_opt */

/*
 *  tcp_get_opt -- TCP ̿üץڳĥǽ
 *
 *  : ǽ TCP ̿üץ̵ᡢE_PAR ֤롣
 */

#ifdef __tcp_get_opt

ER
tcp_get_opt (ID cepid, int_t optname, void *optval, int_t optlen)
{
	T_TCP_CEP	*cep;

	/* TCP ̿ü ID å롣*/
	if (!VALID_TCP_CEPID(cepid))
		return E_ID;

	/* TCP ̿ü롣*/
	cep = GET_TCP_CEP(cepid);

	/* TCP ̿üå롣*/
	if (!VALID_TCP_CEP(cep))
		return E_NOEXS;

	return E_PAR;
	}

#endif	/* of #ifdef __tcp_get_opt */

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

#endif	/* of #ifdef SUPPORT_TCP */
