/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: tcpn_usrreq.c 1.7 2017/6/1 8:49:26 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	From: @(#)tcp_usrreq.c	8.2 (Berkeley) 1/3/94
 * $FreeBSD: src/sys/netinet/tcp_usrreq.c,v 1.40.2.3 1999/08/29 16:29:57 peter Exp $
 */

#ifdef TCP_CFG_EXTENTIONS

#if (API_PROTO == API_PROTO_IPV6 && TNUM_TCP6_REPID > 0) || (API_PROTO == API_PROTO_IPV4 && TNUM_TCP4_REPID > 0)

/*
 *  tcp_cre_rep -- TCP ոڳĥǽ
 */

#ifdef __tcp_cre_rep

ER
TCP_CRE_REP (ID repid, T_TCPN_CREP *pk_crep)
{
	T_TCP_REP	*rep;
	ER		error;

	/* TCP ո ID å롣*/
	if (!VALID_TCP_REPID(repid))
		return E_ID;

	/* pk_crep  NULL ʤ饨顼 */
	if (pk_crep == NULL)
		return E_PAR;

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&pk_crep->myaddr.ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

	/* TCP ո롣*/
	rep = GET_TCP_REP(repid);

	/* TCP ոưŪѤǤʤХ顼 */
	if (!DYNAMIC_TCP_REP(rep))
		return E_ID;

	/* ոå롣*/
	syscall(wai_sem(rep->semid_lock));

	/*
	 * TCP ոå롣ѤߤǤХ顼
	 */
	if (VALID_TCP_REP(rep))
		error = E_OBJ;
	else {

		/* TCP ո򥳥ԡ롣*/
		rep->repatr = pk_crep->repatr;			/* ո°		*/
		rep->myaddr.ipaddr = pk_crep->myaddr.ipaddr;	/* ʬΥɥ쥹	*/
		rep->myaddr.portno = pk_crep->myaddr.portno;	/* ʬΥɥ쥹	*/

		/* TCP ոѤߤˤ롣*/
		rep->flags |= TCP_REP_FLG_VALID;
		error = E_OK;
		}

	/* ոΥå롣*/
	syscall(sig_sem(rep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __tcp_cre_rep */

#ifdef __tcp_del_rep

/*
 *  tcp_find_cep_rep -- TCP ո󥯤Ƥ TCP ̿ü롣
 */

static T_TCP_CEP*
TCP_FIND_CEP_REP (T_TCP_REP* rep)
{
	T_TCP_CEP*	cep;

	for (cep = &tcp_cep[tmax_tcp_cepid]; cep -- != tcp_cep; ) {

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4)
		if (cep->rep4 == rep)
#else
		if (cep->rep == rep)
#endif
			return cep;
		}

	return NULL;
	}

/*
 *  tcp_del_rep_body -- TCP ոκڳĥǽۤ
 */

static ER
TCP_DEL_REP_BODY (ID repid)
{
	T_TCP_CEP	*cep;
	T_TCP_REP	*rep;
	ER		error = E_OK;

	/* TCP ո ID ΥåϽλƤ롣*/

	/* TCP ո롣*/
	rep = GET_TCP_REP(repid);

	/* TCP ոưŪѤǤʤХ顼 */
	if (!DYNAMIC_TCP_REP(rep))
		return E_ID;

	/* ոå롣*/
	syscall(wai_sem(rep->semid_lock));

	/* TCP ոå롣̤ξϥ顼 */
	if (!VALID_TCP_REP(rep))
		error = E_NOEXS;
	else {
		if ((cep = TCP_FIND_CEP_REP(rep)) != NULL) {
			/*
			 * Ǥ˼ưץ󤷤ƤȤ
			 *tcp_acp_cep ƤФƤȤˤϡ
			 * tcp_acp_cep λ롣
			 */

			/* ̿üå롣*/
			syscall(wai_sem(cep->semid_lock));

			/*
			 *  ̿üո
			 *  ٥ȥե饰򥯥ꤹ롣
			 */
			cep->rep = NULL;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
			cep->rep4 = NULL;
#endif

			cep->fsm_state = TCP_FSM_CLOSED;
			cep->error = E_DLT;
			syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));

#ifdef TCP_CFG_NON_BLOCKING

			if (cep->rcv_nblk_tfn != TFN_TCP_UNDEF) {
				if (IS_PTR_DEFINED(cep->callback)) {

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14

					(*cep->callback)(GET_TCP_CEPID(cep), cep->rcv_nblk_tfn, (void*)E_DLT);

#else	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

					ER	error = E_DLT;

					(*cep->callback)(GET_TCP_CEPID(cep), cep->rcv_nblk_tfn, (void*)&error);

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING_COMPAT14 */

					}
				else
					error = E_OBJ;
				cep->rcv_nblk_tfn = TFN_TCP_UNDEF;
				}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

			cep->rcv_tskid = TA_NULL;
			cep->rcv_tfn   = TFN_TCP_UNDEF;

			/* ̿üΥå롣*/
			syscall(sig_sem(cep->semid_lock));

			}
		else
			error = E_OK;

		/* TCP ո̤ˤ롣*/
		rep->flags &= ~TCP_REP_FLG_VALID;
		}

	/* ոΥå롣*/
	syscall(sig_sem(rep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __tcp_del_rep */

#endif	/* of #if (API_PROTO == API_PROTO_IPV6 && TNUM_TCP6_REPID > 0) || (API_PROTO == API_PROTO_IPV4 && TNUM_TCP4_REPID > 0) */

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

#if (API_PROTO == API_PROTO_IPV6 && TNUM_TCP6_REPID > 0) || (API_PROTO == API_PROTO_IPV4 && TNUM_TCP4_REPID > 0)

/*
 *  tcp_acp_cep -- ³׵Ԥ (ưץ)ɸൡǽ
 */

#ifdef __tcp_acp_cep

ER
TCP_ACP_CEP (ID cepid, ID repid, T_IPEP *p_dstaddr, TMO tmout)
{
	T_TCP_REP	*rep;
	T_TCP_CEP	*cep;
	ER		error;
	FLGPTN		flag;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)

	/*
	 * API (tcp6_acp_cep  tcp_acp_cep) ȡ
	 * TCP̿üΥץȥ뤬̷⤷ƤХ顼
	 */

#if API_PROTO == API_PROTO_IPV6

	if (GET_TCP_CEP(cepid)->flags & TCP_CEP_FLG_IPV4)
		return E_ID;

#endif	/* of #if API_PROTO == API_PROTO_IPV6 */

#if API_PROTO == API_PROTO_IPV4

	if ((GET_TCP_CEP(cepid)->flags & TCP_CEP_FLG_IPV4) == 0)
		return E_ID;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

	/* TCP ոå롣*/
	if (!VALID_TCP_REPID(repid))
		return E_ID;

#ifdef TCP_CFG_NON_BLOCKING

	/* p_dstaddr  NULL ʤ饨顼 */
	if (p_dstaddr == NULL)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/* p_dstaddr  NULL tmout  TMO_NBLK ʤ饨顼 */
	if (p_dstaddr == NULL || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&p_dstaddr->ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_ACP_CEP)) != E_OK)
		return error;

	/* CEP  FSM ֤ǤʤХ顼*/
	if (cep->fsm_state != TCP_FSM_CLOSED) {
		error = E_OBJ;
		goto err_ret;
		}
	syscall(clr_flg(cep->est_flgid, (FLGPTN)(~TCP_CEP_EVT_CLOSED)));

	/* TCP ̿ü롣*/
	tcp_init_cep(cep);

	/* TCP ո롣*/

	rep = GET_TCP_REP(repid);

#ifdef TCP_CFG_EXTENTIONS

	/* TCP ոå롣*/
	syscall(wai_sem(rep->semid_lock));

	/* TCP ոå롣*/
	if (!VALID_TCP_REP(rep)) {
		syscall(sig_sem(rep->semid_lock));
		error = E_NOEXS;
		goto err_ret;
		}

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

	/* TCP ̿üTCPոϿ롣*/

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)

#if API_PROTO == API_PROTO_IPV6

	cep->rep = rep;

#else	/* of #if API_PROTO == API_PROTO_IPV6 */

	cep->rep4 = rep;

#endif	/*of #if API_PROTO == API_PROTO_IPV6 */

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

	cep->rep = rep;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

#ifdef TCP_CFG_EXTENTIONS

	/* TCP ոΥå롣*/
	syscall(sig_sem(rep->semid_lock));

#endif	/* of #ifdef TCP_CFG_EXTENTIONS */

	/* TCP ոΥɥ쥹򥳥ԡ롣*/

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4)

	if (rep->myaddr.ipaddr == IPV4_ADDRANY)
		memcpy(&cep->myaddr.ipaddr, &in6_addr_unspecified,
		                      sizeof(in6_addr_unspecified));
	else
		in6_make_ipv4mapped(&cep->myaddr.ipaddr, rep->myaddr.ipaddr);
	cep->myaddr.portno = rep->myaddr.portno;

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

	cep->myaddr = rep->myaddr;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

#if API_PROTO == API_PROTO_IPV4

	/* TCP ̿üΥͥåȥإץȥꤹ롣*/
	cep->flags |= TCP_CEP_FLG_IPV4;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

	/* ̿üꤹ롣*/
	cep->fsm_state = TCP_FSM_LISTEN;

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)

#if API_PROTO == API_PROTO_IPV4

		cep->p_dstaddr4   = p_dstaddr;
		cep->p_dstaddr    = NULL;

#else	/* of #if API_PROTO == API_PROTO_IPV4 */

		cep->p_dstaddr4   = NULL;
		cep->p_dstaddr    = p_dstaddr;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

		cep->p_dstaddr    = p_dstaddr;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

		cep->rcv_nblk_tfn = TFN_TCP_ACP_CEP;
		return E_WBLK;
		}
	else {

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/*
		 *  FSM  ESTABLISHED ˤʤޤԤġ
		 *  FSM  CLOSED ˤʤäϡ顼ȯȤ̣Ƥ롣
		 */
		error = twai_flg(cep->est_flgid, (TCP_CEP_EVT_CLOSED |
		                                  TCP_CEP_EVT_ESTABLISHED), TWF_ORW, &flag, tmout);
		if (error == E_OK) {
			if (cep->error != E_OK)
				error = cep->error;
			else if (cep->fsm_state == TCP_FSM_CLOSED)
				error = E_TMOUT;
			}

		syscall(clr_flg(cep->est_flgid, (FLGPTN)(~TCP_CEP_EVT_ESTABLISHED)));

		if (error == E_OK) {
			/* Υɥ쥹򥳥ԡ롣*/
#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4)
			p_dstaddr->ipaddr = ntohl(cep->dstaddr.ipaddr.s6_addr32[3]);
			p_dstaddr->portno = cep->dstaddr.portno;
#else
			*p_dstaddr = cep->dstaddr;
#endif
			}
		else {
			/*
			 *  ̿üո
			 *  ٥ȥե饰򥯥ꤹ롣
			 */
			cep->rep = NULL;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
			cep->rep4 = NULL;
#endif

			cep->fsm_state = TCP_FSM_CLOSED;
			syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
			}

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->rcv_tskid = TA_NULL;
	cep->rcv_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_acp_cep */

#endif	/* of #if (API_PROTO == API_PROTO_IPV6 && TNUM_TCP6_REPID > 0) || (API_PROTO == API_PROTO_IPV4 && TNUM_TCP4_REPID > 0) */

/*
 *  tcp_con_cep -- ³׵ (ǽưץ)ɸൡǽ
 */

#ifdef __tcp_con_cep

ER
TCP_CON_CEP (ID cepid, T_IPEP *p_myaddr, T_IPEP *p_dstaddr, TMO tmout)
{
	T_TCP_CEP	*cep;
	ER		error;
	FLGPTN		flag;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)

	/*
	 * API (tcp6_acp_cep  tcp_acp_cep) ȡ
	 * TCP̿üΥץȥ뤬̷⤷ƤХ顼
	 */

#if API_PROTO == API_PROTO_IPV6

	if (GET_TCP_CEP(cepid)->flags & TCP_CEP_FLG_IPV4)
		return E_ID;

#endif	/* of #if API_PROTO == API_PROTO_IPV6 */

#if API_PROTO == API_PROTO_IPV4

	if ((GET_TCP_CEP(cepid)->flags & TCP_CEP_FLG_IPV4) == 0)
		return E_ID;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

	/*
	 *  褬ޥ㥹ȥɥ쥹ʤ饨顼
	 */

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4)

	if (IN4_IS_ADDR_MULTICAST(p_dstaddr->ipaddr))
		return E_PAR;

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

	if (IN_IS_ADDR_MULTICAST(&p_dstaddr->ipaddr))
		return E_PAR;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&p_dstaddr->ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

#ifdef TCP_CFG_NON_BLOCKING

	/*
	 *  p_dstaddr ޤ p_myaddr  NULL ʤ饨顼
	 */
	if (p_myaddr == NULL || p_dstaddr == NULL)
		return E_PAR;

#else	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  p_dstaddr ޤ p_myaddr  NULL 
	 *  tmout  TMO_NBLK ʤ饨顼
	 */
	if (p_myaddr == NULL || p_dstaddr == NULL || tmout == TMO_NBLK)
		return E_PAR;

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

	/*
	 *  CEP åAPI ǽɤȥ̻ҤϿ롣
	 *  Ǥ˵ϿƤСڥǥʤΤǥ顼
	 */
	if ((error = tcp_lock_cep(cepid, &cep, TFN_TCP_CON_CEP)) != E_OK)
		return error;

	/* CEP  FSM ֤ǤʤХ顼*/
	if (cep->fsm_state != TCP_FSM_CLOSED) {
		error = E_OBJ;
		goto err_ret;
		}
	syscall(clr_flg(cep->est_flgid, (FLGPTN)(~TCP_CEP_EVT_CLOSED)));

	/* ֹ롣*/
	if (tcp_iss == 0)
		tcp_init_iss();

	/* ̿ü롣*/
	tcp_init_cep(cep);

	/*
	 *  IP ɥ쥹ꤹ롣
	 *  p_myaddr  NADR (-1) ǤϤʤ IP ɥ쥹 ANY ǤʤС
	 *  ꤵ줿 IP ɥ쥹Ƥ롣
	 */

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4)

	if (p_myaddr != NADR && !IN4_IS_ADDR_ANY(&p_myaddr->ipaddr))
		in6_make_ipv4mapped(&cep->myaddr.ipaddr, p_myaddr->ipaddr);
	else
		in6_make_ipv4mapped(&cep->myaddr.ipaddr, IF_GET_IFNET()->in4_ifaddr.addr);

	in6_make_ipv4mapped(&cep->dstaddr.ipaddr, p_dstaddr->ipaddr);
	cep->dstaddr.portno = p_dstaddr->portno;

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

	if (p_myaddr != NADR && !IN_IS_ADDR_ANY(&p_myaddr->ipaddr))
		cep->myaddr.ipaddr = p_myaddr->ipaddr;
	else {
		if (IN_ADDRWITHIFP(IF_GET_IFNET(), &cep->myaddr.ipaddr, &p_dstaddr->ipaddr) == NULL) {
			error = E_PAR;
			goto err_ret;
			}
		}

	cep->dstaddr   = *p_dstaddr;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) && (API_PROTO == API_PROTO_IPV4) */

#if API_PROTO == API_PROTO_IPV4

	/* TCP ̿üΥͥåȥإץȥꤹ롣*/
	cep->flags |= TCP_CEP_FLG_IPV4;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

	/* ̿üꤹ롣*/
	//NET_DEBUG_TCP5("tcp_con_cep3[c=%d,d=%lI.%d,s=%lI.%d]\n",
	cep->fsm_state = TCP_FSM_SYN_SENT;
	cep->iss       = tcp_iss;
	cep->timer[TCP_TIM_KEEP] = TCP_TVAL_KEEP_INIT;
	tcp_iss += TCP_ISS_INCR() / 2;
	init_send_seq(cep);

#ifdef TCP_CFG_NON_BLOCKING

	/* ॢȤå롣*/
	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)

#if API_PROTO == API_PROTO_IPV4

		cep->p_dstaddr4   = p_dstaddr;
		cep->p_myaddr4    = p_myaddr;
		cep->p_dstaddr    = NULL;
		cep->p_myaddr     = NULL;

#else	/* of #if API_PROTO == API_PROTO_IPV4 */

		cep->p_dstaddr4   = NULL;
		cep->p_myaddr4    = NULL;
		cep->p_dstaddr    = p_dstaddr;
		cep->p_myaddr     = p_myaddr;

#endif	/* of #if API_PROTO == API_PROTO_IPV4 */

#else	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

		cep->p_dstaddr    = p_dstaddr;
		cep->p_myaddr     = p_myaddr;

#endif	/* of #if defined(SUPPORT_INET6) && defined(SUPPORT_INET4) */

		cep->snd_nblk_tfn = TFN_TCP_CON_CEP;

		/* ͥγߤݥȤ롣*/
		cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);
		return E_WBLK;
		}
	else {

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

		/*
		 *  p_myaddr  NADR (-1) 
		 *  ݡֹ椬 TCP_PORTANY ʤ顢ưǳƤ롣
		 */
		if (p_myaddr == NADR || p_myaddr->portno == TCP_PORTANY)
			tcp_alloc_auto_port(cep);
		else if ((error = tcp_alloc_port(cep, p_myaddr->portno)) != E_OK)
			goto err_ret;

		/* ͥγߤݥȤ롣*/
		cep->flags |= TCP_CEP_FLG_POST_OUTPUT;
		sig_sem(SEM_TCP_POST_OUTPUT);

		/*
		 *  ٥Ȥ ESTABLISHED ˤʤޤԤġ
		 *  ٥Ȥ CLOSED ˤʤäϡ餫Υ顼ȯ
		 *  ³׵᤬ݤ줿Ȥ̣Ƥ롣
		 */
		error = twai_flg(cep->est_flgid, (TCP_CEP_EVT_CLOSED |
		                                  TCP_CEP_EVT_ESTABLISHED), TWF_ORW, &flag, tmout);
		if (error == E_OK) {
			if (cep->error != E_OK)
				error = cep->error;
			else if (cep->fsm_state == TCP_FSM_CLOSED)
				error = E_CLS;
			}

		syscall(clr_flg(cep->est_flgid, (FLGPTN)(~TCP_CEP_EVT_ESTABLISHED)));

		if (error != E_OK) {
			/*
			 *  ̿üո
			 *  ٥ȥե饰򥯥ꤹ롣
			 */
			cep->rep = NULL;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
			cep->rep4 = NULL;
#endif

			cep->fsm_state = TCP_FSM_CLOSED;
			syscall(set_flg(cep->est_flgid, TCP_CEP_EVT_CLOSED));
			}

#ifdef TCP_CFG_NON_BLOCKING

		}

#endif	/* of #ifdef TCP_CFG_NON_BLOCKING */

err_ret:
	cep->snd_tskid = TA_NULL;
	cep->snd_tfn   = TFN_TCP_UNDEF;
	return error;
	}

#endif	/* of #ifdef __tcp_con_cep */
