/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_var.h 1.7 2017/6/1 8:49:39 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_var.h	8.1 (Berkeley) 6/10/93
 * $FreeBSD: src/sys/netinet/udp_var.h,v 1.16.2.2 1999/08/29 16:29:59 peter Exp $
 */
 
#ifndef _UDP_VAR_H_
#define _UDP_VAR_H_

/*
 *  UDP إåڥɥޥ
 */

#define GET_UDP_HDR(nbuf,uhoff)		((T_UDP_HDR*)((uint8_t*)((nbuf)->buf) + uhoff))
#define GET_UDP_HDR_OFFSET(nbuf)	(GET_IF_IP_HDR_SIZE(nbuf))
#define GET_UDP_SDU(nbuf,uhoff)		((uint8_t*)((nbuf)->buf) + uhoff+ UDP_HDR_SIZE)

#define IF_IP_UDP_HDR_SIZE(nbuf)	(IF_IP_HDR_SIZE(nbuf) + UDP_HDR_SIZE)
#define IF_IP_UDP_HDR_OFFSET(nbuf)	(IF_IP_HDR_SIZE(nbuf))

/*
 *  TINET 1.1 ȤθߴΤ
 */

#if defined(_IP4_CFG)

#define IP4_UDP_HDR_SIZE		IP_UDP_HDR_SIZE
#define IF_IP4_UDP_HDR_SIZE		IF_IP_UDP_HDR_SIZE
#define GET_IP4_UDP_HDR_SIZE(nbuf)	GET_IP_UDP_HDR_SIZE(nbuf)	
#define GET_IF_IP4_UDP_HDR_SIZE(nbuf)	GET_IF_IP_UDP_HDR_SIZE(nbuf)

#endif	/* of #if defined(_IP4_CFG) */

/*
 *  Хåؿ
 */

typedef ER	(*t_udp_callback)(ID cepid, FN fncd, void *p_parblk);

/*
 *  UDP ̿ü
 */

/* IPv6  UDP ̿ü */

typedef struct t_udp6_cep {

	/*
	 * ITRON TCP/IP APITCP ̿üƱ
	 */
	ATR		cepatr;		/* UDP ̿ü°		*/
	T_IPV6EP	myaddr;		/* ʬΥɥ쥹		*/
	t_udp_callback	callback;	/* Хåؿ		*/

	/*
	 * TINET ȼΥ
	 */
	uint16_t	flags;		/* ̿üե饰		*/
	ID		semid_lock;	/* ̿üå		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	ID		rcvqid;		/* 󥳡ХåѼ塼̻*/
	T_NET_BUF	*cb_netbuf;	/* ХåѼͥåȥХåե*/

#ifdef UDP_CFG_NON_BLOCKING

	T_IPV6EP 	*snd_p_dstaddr;	/* Υɥ쥹ؤΥݥ*/
	T_IPV6EP 	*rcv_p_dstaddr;	/* Υɥ쥹ؤΥݥ*/
	void		*snd_data;	/* ǡΰƬɥ쥹	*/
	int_t		snd_len;	/* ǡΰĹ		*/
	void		*rcv_data;	/* ǡΰƬɥ쥹	*/
	int_t		rcv_len;	/* ǡΰĹ		*/

#endif	/* of #ifdef UDP_CFG_NON_BLOCKING */

#ifdef UDP_CFG_EXTENTIONS
	ER		error;		/* Ԥȯ顼	*/
#endif

	} T_UDP6_CEP;

/* IPv4  UDP ̿ü */

typedef struct t_udp4_cep {

	/*
	 * ITRON TCP/IP APITCP ̿üƱ
	 */
	ATR		cepatr;		/* UDP ̿ü°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	t_udp_callback	callback;	/* Хåؿ		*/

	/*
	 * TINET ȼΥ
	 */
	uint16_t	flags;		/* ̿üե饰		*/
	ID		semid_lock;	/* ̿üå		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	ID		rcvqid;		/* 󥳡ХåѼ塼̻*/
	T_NET_BUF	*cb_netbuf;	/* ХåѼͥåȥХåե*/

#ifdef UDP_CFG_NON_BLOCKING

	T_IPV4EP 	*snd_p_dstaddr;	/* Υɥ쥹ؤΥݥ*/
	T_IPV4EP	*rcv_p_dstaddr;	/* Υɥ쥹ؤΥݥ*/
	void		*snd_data;	/* ǡΰƬɥ쥹	*/
	int_t		snd_len;	/* ǡΰĹ		*/
	void		*rcv_data;	/* ǡΰƬɥ쥹	*/
	int_t		rcv_len;	/* ǡΰĹ		*/

#endif	/* of #ifdef UDP_CFG_NON_BLOCKING */

#ifdef UDP_CFG_EXTENTIONS
	ER		error;		/* Ԥȯ顼	*/
#endif

	} T_UDP4_CEP;

#if defined(_IP6_CFG)

#define T_UDP_CEP	T_UDP6_CEP

#else	/* of #if defined(_IP6_CFG) */

#if defined(_IP4_CFG)

#define T_UDP_CEP	T_UDP4_CEP

#endif	/* of #if defined(_IP4_CFG) */

#endif	/* of #if defined(_IP6_CFG) */

/*
 *  UDP ̿üե饰
 */

#define UDP_CEP_FLG_POST_OUTPUT	UINT_C(0x0200)	/* 򳫻Ϥ롣		*/
#define UDP_CEP_FLG_DYNAMIC	UINT_C(0x0400)	/* ưŪǽ̿ü	*/
#define UDP_CEP_FLG_VALID	UINT_C(0x0800)	/* Ѥߤͭ̿ü	*/

/*
 *  ֥ ID κǾͤ
 */

#define	TMIN_UDP_CEPID		1			/* UDP      ̿ü ID κǾ */
#define	TMIN_UDP6_CEPID		1			/* UDP/IPv6 ̿ü ID κǾ */
#define	TMIN_UDP4_CEPID		(TNUM_UDP6_CEPID+1)	/* UDP/IPv4 ̿ü ID κǾ */

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_udp_stats {
	uint32_t	udpInDatagrams;
	uint32_t	udpNoPorts;
	uint32_t	udpInErrors;
	uint32_t	udpOutDatagrams;
} T_UDP_STATS;

/*
 *  ؿߥ졼ޥ
 */

#define VALID_UDP6_CEPID(id)	(TMIN_UDP6_CEPID<=(id)&&(id)<=tmax_udp6_cepid)
#define VALID_UDP4_CEPID(id)	(TMIN_UDP4_CEPID<=(id)&&(id)<=tmax_udp4_cepid)

#define INDEX_UDP6_CEP(id)	((id)-TMIN_UDP6_CEPID)
#define INDEX_UDP4_CEP(id)	((id)-TMIN_UDP4_CEPID)

#define GET_UDP6_CEP(id)	(&(udp6_cep[INDEX_UDP6_CEP(id)]))
#define GET_UDP4_CEP(id)	(&(udp4_cep[INDEX_UDP4_CEP(id)]))

#define GET_UDP6_CEPID(cep)	((ID)(((cep)-udp6_cep)+TMIN_UDP6_CEPID))
#define GET_UDP4_CEPID(cep)	((ID)(((cep)-udp4_cep)+TMIN_UDP4_CEPID))

#define VALID_TFN_UDP_CAN(t)	((t)==TFN_UDP_SND_DAT||(t)==TFN_UDP_RCV_DAT||\
				 (t)==TFN_UDP_ALL)

#define VALID_UDP_CEP(cep)	(((cep)->flags&UDP_CEP_FLG_VALID)!=0)
#define DYNAMIC_UDP_CEP(cep)	(((cep)->flags&UDP_CEP_FLG_DYNAMIC)!=0)

/*
 *  ѿ
 */

extern T_UDP_STATS udp_stats;

/* UDP ̿ü */

extern T_UDP6_CEP udp6_cep[];
extern T_UDP4_CEP udp4_cep[];

#if defined(SUPPORT_INET6)
#define udp_cep	udp6_cep
#elif defined(SUPPORT_INET4)
#define udp_cep	udp4_cep
#endif

extern const ID tmax_udp_cepid;

#if defined(SUPPORT_INET6) && defined(SUPPORT_INET4)
extern const ID tmax_udp6_cepid;
extern const ID tmax_udp4_cepid;
#else
#define tmax_udp6_cepid	tmax_udp_cepid
#define tmax_udp4_cepid	tmax_udp_cepid
#endif

/*
 *  TINET 1.3 ȤθߴΤ
 */

#define	TMIN_UDP_CCEPID		TMIN_UDP_CEPID
#define	TNUM_UDP_CCEPID		TNUM_UDP_CEPID

/*
 *  ؿ
 */

/* IPv6 */

extern uint_t udp6_input (T_NET_BUF **inputp, uint_t *offp, uint_t *nextp);
extern ER_UINT udp6_send_data (T_UDP6_CEP *cep, T_IPV6EP *p_dstaddr,
                               void *data, int_t len, TMO tmout);
extern ER udp6_can_snd (T_UDP6_CEP *cep, ER error);
extern ER udp6_can_rcv (T_UDP6_CEP *cep, ER error);
extern ER udp6_alloc_auto_port (T_UDP6_CEP *cep);
extern ER udp6_alloc_port (T_UDP6_CEP *cep, uint16_t portno);
extern T_UDP6_CEP*udp6_find_cep (T_NET_BUF *input, uint_t off);
extern void udp6_notify (T_NET_BUF *input, ER error);
extern void udp6_input_select (T_UDP6_CEP *cep, T_NET_BUF *input, uint_t off);

/* IPv4 */

extern uint_t udp4_input (T_NET_BUF **inputp, uint_t *offp, uint_t *nextp);
extern ER_UINT udp4_send_data (T_UDP4_CEP *cep, T_IPV4EP *p_dstaddr,
                               void *data, int_t len, TMO tmout);
extern ER udp4_can_snd (T_UDP4_CEP *cep, ER error);
extern ER udp4_can_rcv (T_UDP4_CEP *cep, ER error);
extern ER udp4_alloc_auto_port (T_UDP4_CEP *cep);
extern ER udp4_alloc_port (T_UDP4_CEP *cep, uint16_t portno);
extern T_UDP4_CEP*udp4_find_cep (T_NET_BUF *input, uint_t off);
extern void udp4_notify (T_NET_BUF *input, ER error);
extern void udp4_input_select (T_UDP4_CEP *cep, T_NET_BUF *input, uint_t off);

/* Υ֥å󥰥ԤȤ߹ॿ */

extern void	udp_output_task(intptr_t exinf);

#endif	/* of #ifndef _UDP_VAR_H_ */
