/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udpn_input.c 1.7 2017/6/1 8:49:29 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#if (API_PROTO == API_PROTO_IPV6) || (TNUM_UDP4_CEPID > 0)

/*
 *  udp_input_select -- UDP Ͻ
 */

void
UDP_INPUT_SELECT (T_UDP_CEP *cep, T_NET_BUF *input, uint_t off)
{
	T_UDP_HDR	*udph;
	uint_t		len;

	udph = (T_UDP_HDR *)(input->buf + off);
	len  = (uint_t)(ntohs(udph->ulen) - UDP_HDR_SIZE);

	if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (psnd_dtq(cep->rcvqid, (intptr_t)input) != E_OK) {
			NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
			NET_COUNT_MIB(udp_stats.udpInErrors, 1);
			syscall(rel_net_buf(input));
			}
		}

#ifdef UDP_CFG_NON_BLOCKING

	else if (cep->rcv_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */

		/* p_dstaddr ꤹ롣*/
		cep->rcv_p_dstaddr->portno = ntohs(udph->sport);
		IN_COPY_TO_HOST(&cep->rcv_p_dstaddr->ipaddr, input);

		/* ǡХåե˰ܤ*/
		memcpy(cep->rcv_data, GET_UDP_SDU(input, off),
		       (size_t)(len < cep->rcv_len ? len : cep->rcv_len));
		syscall(rel_net_buf(input));

		if (IS_PTR_DEFINED(cep->callback))

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)(uint32_t)len);
#else
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)&len);
#endif
		else
			syslog(LOG_WARNING, "[UDP] no call back, CEP: %d.", GET_UDP_CEPID(cep));
		cep->rcv_p_dstaddr = NULL;
		}

#endif/* of #ifdef UDP_CFG_NON_BLOCKING */

	else if (IS_PTR_DEFINED(cep->callback)) {

		/* ХåؿƤӽФ*/
		cep->cb_netbuf = input;

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
		(*cep->callback)(GET_UDP_CEPID(cep), TEV_UDP_RCV_DAT, (void*)(uint32_t)len);
#else
		(*cep->callback)(GET_UDP_CEPID(cep), TEV_UDP_RCV_DAT, (void*)&len);
#endif
		/*
		 *  ͥåȥХåեΤޤޤǤСХåؿ
		 *  ǡɤ߽ФʤäȤˤʤΤǡΤƤ롣
		 */
		if (cep->cb_netbuf != NULL)
			syscall(rel_net_buf(cep->cb_netbuf));
		}
	else {
		NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
		NET_COUNT_MIB(udp_stats.udpInErrors, 1);
		syscall(rel_net_buf(input));
		}

	}

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) || (TNUM_UDP4_CEPID > 0) */

/*
 *  udp_input -- UDP ϴؿ
 */

uint_t
UDP_INPUT (T_NET_BUF **inputp, uint_t *offp, uint_t *nextp)
{
	T_NET_BUF	*input = *inputp;
	T_UDP_CEP	*cep;
	T_UDP_HDR	*udph;
	uint_t		hlen, ulen;

#if defined(_IP6_CFG) && defined(_IP4_CFG) && API_PROTO == API_PROTO_IPV4
	T_UDP6_CEP	*cep6;
#endif

	hlen = (uint_t)GET_IF_IP_HDR_SIZE(input);

	NET_COUNT_UDP(net_count_udp.in_octets,  input->len - hlen);
	NET_COUNT_UDP(net_count_udp.in_packets, 1);
	NET_COUNT_MIB(udp_stats.udpInDatagrams, 1);

	/* إåĹå롣*/
	if (input->len < hlen + UDP_HDR_SIZE)
		goto buf_rel;

	udph = (T_UDP_HDR *)(input->buf + *offp);

	/* ǡĹå */
	ulen  = ntohs(udph->ulen);
	if (ulen != input->len - hlen)
		goto buf_rel;

	/* ݡȤ 0 Υǡ˴롣RFC768 */
	if (udph->dport == 0)
		goto buf_rel;

#ifdef UDP_CFG_IN_CHECKSUM

	/* åå */
	if (udph->sum && IN_CKSUM(input, IPPROTO_UDP, *offp, ulen) != 0)
		goto buf_rel;

#endif	/* of #ifdef UDP_CFG_IN_CHECKSUM */

#if defined(_IP6_CFG) && defined(_IP4_CFG) && API_PROTO == API_PROTO_IPV4

#if TNUM_UDP4_CEPID > 0

	/* UDP ̿ü롣*/
	cep = udp4_find_cep(input, *offp);

	if (cep != NULL)
		udp4_input_select(cep, input, *offp);
	else if ((cep6 = udp6_find_cep(input, *offp)) != NULL)
		udp6_input_select(cep6, input, *offp);
	else
		udp4_reply_no_port(input, *offp);

	return IPPROTO_DONE;

#else	/* of #if TNUM_UDP4_CEPID > 0 */

	cep = 0;	/* warning ѤΥߡ */
	if ((cep6 = udp6_find_cep(input, *offp)) != NULL)
		udp6_input_select(cep6, input, *offp);
	else
		udp4_reply_no_port(input, *offp);

	return IPPROTO_DONE;

#endif	/* of #if TNUM_UDP4_CEPID > 0 */

#else	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) && API_PROTO == API_PROTO_IPV4 */

	/* UDP ̿ü롣*/
	cep = UDP_FIND_CEP(input, *offp);

	if (cep != NULL)
		UDP_INPUT_SELECT(cep, input, *offp);
	else
		UDP_REPLY_NO_PORT(input, *offp);

	return IPPROTO_DONE;

#endif	/* of #if defined(_IP6_CFG) && defined(_IP4_CFG) && API_PROTO == API_PROTO_IPV4 */

buf_rel:
	NET_COUNT_UDP(net_count_udp.in_err_packets, 1);
	NET_COUNT_MIB(udp_stats.udpInErrors, 1);
	syscall(rel_net_buf(input));
	return IPPROTO_DONE;
	}
