/*
 *  TINET (UDP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udpn_usrreq.c 1.7 2017/6/1 8:49:30 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must ceproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_usrreq.c	8.6 (Berkeley) 5/23/95
 * $FreeBSD: src/sys/netinet/udp_usrreq.c,v 1.49.2.2 1999/08/29 16:29:58 peter Exp $
 */

#ifdef __udp_send_data

/*
 *  udp_send_data -- ѥåμ
 */

ER_UINT
UDP_SEND_DATA (T_UDP_CEP *cep, T_IPEP *p_dstaddr, void *data, int_t len, TMO tmout)
{
	T_NET_BUF	*output;
	T_UDP_HDR	*udph;
	SYSTIM		before, after;
	ER		error = E_OK;

#ifdef UDP_CFG_OUT_CHECKSUM
	uint16_t	sum;
#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	NET_COUNT_UDP(net_count_udp.out_octets,  len);
	NET_COUNT_UDP(net_count_udp.out_packets, 1);

	/* IP ǡƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR))
		syscall(get_tim(&before));

	/* IP ǡƤ롣*/
	if ((error = IN_GET_DATAGRAM(&output, (uint_t)(UDP_HDR_SIZE + len), 0,
	                             &p_dstaddr->ipaddr,
	                             &cep->myaddr.ipaddr,
	                             IPPROTO_UDP, IP_DEFTTL, 
	                             NBA_SEARCH_ASCENT, tmout)) != E_OK)
		goto err_ret;

	/* IP ǡƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
		syscall(get_tim(&after));
		if (after - before > tmout) {
			syscall(rel_net_buf(output));
			error = E_TMOUT;
			goto err_ret;
			}
		tmout -= (TMO)(after - before);
		}

	/* UDP إå˾ꤹ롣*/
	udph		= GET_UDP_HDR(output, IF_IP_UDP_HDR_OFFSET(output));
	udph->sport	= htons(cep->myaddr.portno);
	udph->dport	= htons(p_dstaddr->portno);
	udph->ulen	= htons(UDP_HDR_SIZE + len);
	udph->sum	= 0;

	/* ǡ򥳥ԡ롣*/
	memcpy((void*)GET_UDP_SDU(output, IF_IP_UDP_HDR_OFFSET(output)), data, (size_t)len);

#ifdef UDP_CFG_OUT_CHECKSUM

	sum = IN_CKSUM(output, IPPROTO_UDP, IF_IP_UDP_HDR_OFFSET(output), (uint_t)(UDP_HDR_SIZE + len));

	/* ׻åͤ 0 ʤ 0xffff 롣*/
	if (sum == 0)
		sum = 0xffff;
	udph->sum = sum;

#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	/* ͥåȥХåեĹĴ롣*/
	output->len = (uint16_t)(IF_IP_UDP_HDR_SIZE(output) + len);

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	if ((error = IP_OUTPUT(output, tmout)) == E_OK) {
		NET_COUNT_MIB(udp_stats.udpOutDatagrams, 1);
		cep->snd_tskid = TA_NULL;
		return len;
		}

err_ret:
	NET_COUNT_UDP(net_count_udp.out_err_packets, 1);
	cep->snd_tskid = TA_NULL;
	return error;
	}

#endif	/* of #ifdef __udp_send_data */

/*
 *  udp_cancel_cep -- ڥǥ󥰤Ƥ򥭥󥻥뤹롣
 *
 *    udp_can_cep ƽФᥤؿ
 */

#ifdef __udp_can_cep

static ER
UDP_CANCEL_CEP (T_UDP_CEP *cep, FN fncd)
{
	ER	error = E_OK, snd_err, rcv_err;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/* API ǽɤå롣*/
	if (!VALID_TFN_UDP_CAN(fncd))
		return E_PAR;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (fncd == TFN_UDP_ALL) {	/* TFN_UDP_ALL ν */

		snd_err = UDP_CAN_SND(cep, E_RLWAI);
		rcv_err = UDP_CAN_RCV(cep, E_RLWAI);

		/*
		 *  snd_err  rcv_err Τɤ EV_NOPND
		 *  ʤ顢ڥǥ󥰤ƤʤΤǥ顼
		 */
		if (snd_err == EV_NOPND && rcv_err == EV_NOPND)
			error = E_OBJ;
		else {
			if (snd_err == EV_NOPND)
				snd_err = E_OK;
			if (rcv_err == EV_NOPND)
				rcv_err = E_OK;

			if (snd_err != E_OK)
				error = snd_err;
			else if (rcv_err != E_OK)
				error = rcv_err;
			}
		}
	else if (fncd == TFN_UDP_SND_DAT) {	/* Υ󥻥 */
		if ((error = UDP_CAN_SND(cep, E_RLWAI)) == EV_NOPND)
			error = E_OBJ;
		}
	else if (fncd == TFN_UDP_RCV_DAT) {	/* Υ󥻥 */
		if ((error = UDP_CAN_RCV(cep, E_RLWAI)) == EV_NOPND)
			error = E_OBJ;
		}
	else
		error = E_PAR;

	/* ̿üå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __udp_can_cep */

#if defined(SUPPORT_INET6) && (defined(SUPPORT_INET4) && TNUM_UDP4_CEPID > 0)

#else	/* of #if defined(SUPPORT_INET6) && (defined(SUPPORT_INET4) && TNUM_UDP4_CEPID > 0) */

/*
 *  udp_can_cep -- ڥǥ󥰤ƤΥ󥻥ɸൡǽ
 */

#ifdef __udp_can_cep

ER
udp_can_cep (ID cepid, FN fncd)
{
	T_UDP_CEP	*cep;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* ᥤؿƤӽФ*/
	return UDP_CANCEL_CEP(cep, fncd);
	}

#endif	/* of #ifdef __udp_can_cep */

#endif	/* of #if defined(SUPPORT_INET6) && (defined(SUPPORT_INET4) && TNUM_UDP4_CEPID > 0) */

#ifdef UDP_CFG_EXTENTIONS

/*
 *  udp_cre_cep -- UDP ̿üڳĥǽ
 */

#ifdef __udp_cre_cep

ER
UDP_CRE_CEP (ID cepid, T_UDPN_CCEP *pk_ccep)
{
	T_UDP_CEP	*cep;
	ER		error;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* pk_ccep  NULL ʤ饨顼 */
	if (pk_ccep == NULL)
		return E_PAR;

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&pk_ccep->myaddr.ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* UDP ̿üå롣*/
	if (VALID_UDP_CEP(cep))
		return E_OBJ;

	/* UDP ̿üưŪѤǤʤХ顼 */
	if (!DYNAMIC_UDP_CEP(cep))
		return E_ID;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 * UDP ̿üå롣ѤߤǤХ顼
	 */
	if (VALID_UDP_CEP(cep))
		error = E_OBJ;
	else {

		/*
		 *  ݡֹ椬 UDP_PORTANY ʤ顢ưǳƤ롣
		 */
		if (pk_ccep->myaddr.portno == UDP_PORTANY)
			error = UDP_ALLOC_AUTO_PORT(cep);
		else 
			error = UDP_ALLOC_PORT(cep, pk_ccep->myaddr.portno);
		
                if (error == E_OK) {

			/* UDP ̿ü򥳥ԡ롣*/
			cep->cepatr        = pk_ccep->cepatr;			/* ̿ü°		*/
			cep->myaddr.ipaddr = pk_ccep->myaddr.ipaddr;		/* ʬΥɥ쥹	*/
			cep->callback      = (void*)pk_ccep->callback;		/* Хå		*/

			/* UDP ̿üѤߤˤ롣*/
			cep->flags |= UDP_CEP_FLG_VALID;
			}
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

#endif	/* of #ifdef __udp_cre_cep */

#ifdef __udp_del_cep

/*
 *  udp_delete_cep -- UDP ̿ü롣
 *
 *    udp_del_cep ƽФᥤؿ
 */

static ER
UDP_DELETE_CEP (T_UDP_CEP *cep)
{
	ER	error;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/* UDP ̿üưŪѤǤʤХ顼 */
	if (!DYNAMIC_UDP_CEP(cep))
		return E_ID;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	/*
	 * UDP ̿üå롣̤ξϥ顼
	 * ̤
	 */
	if (!VALID_UDP_CEP(cep))
		error = E_NOEXS;
	else {
		UDP_CAN_SND(cep, E_DLT);
		UDP_CAN_RCV(cep, E_DLT);

		/* UDP ̿ṳ̈ˤ롣*/
		cep->flags &= ~UDP_CEP_FLG_VALID;
		error = E_OK;
		}

	/* ̿üΥå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  udp_del_cep -- UDP ̿üκڳĥǽ
 */

ER
UDP_DEL_CEP (ID cepid)
{
	T_UDP_CEP	*cep;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* ᥤؿƤӽФ*/
	return UDP_DELETE_CEP(cep);
	}

#endif	/* of #ifdef __udp_del_cep */

#ifdef __udp_set_opt

/*
 *  udp_set_option -- UDP ̿üץꤹ롣
 *
 *    udp_set_opt ƽФᥤؿ
 */

static ER
UDP_SET_OPTION (T_UDP_CEP *cep, int_t optname, void *optval, int_t optlen)
{
	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	return E_PAR;
	}

/*
 *  udp_set_opt -- UDP ̿üץڳĥǽ
 *
 *  : ǽ UDP ̿üץ̵ᡢE_PAR ֤롣
 */

ER
UDP_SET_OPT (ID cepid, int_t optname, void *optval, int_t optlen)
{
	T_UDP_CEP	*cep;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* ᥤؿƤӽФ*/
	return UDP_SET_OPTION(cep, optname, optval, optlen);
	}

#endif	/* of #ifdef __udp_set_opt */

#ifdef __udp_get_opt

/*
 *  udp_get_option -- UDP ̿üץ롣
 *
 *    udp_get_opt ƽФᥤؿ
 */

static ER
UDP_GET_OPTION (T_UDP_CEP *cep, int_t optname, void *optval, int_t optlen)
{
	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	return E_PAR;
	}

/*
 *  udp_get_opt -- UDP ̿üץγڳĥǽ
 *
 *  : ǽ UDP ̿üץ̵ᡢE_PAR ֤롣
 */

ER
UDP_GET_OPT (ID cepid, int_t optname, void *optval, int_t optlen)
{
	T_UDP_CEP	*cep;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* ᥤؿƤӽФ*/
	return UDP_GET_OPTION(cep, optname, optval, optlen);
	}

#endif	/* of #ifdef __udp_get_opt */

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

#ifdef UDP_CFG_NON_BLOCKING

#else	/* of #ifdef UDP_CFG_NON_BLOCKING */

#ifdef __udp_can_snd

/*
 *  udp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

ER
UDP_CAN_SND (T_UDP_CEP *cep, ER error)
{
	if (cep->snd_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꤹ롣*/
		cep->error = error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		error = rel_wai(cep->snd_tskid);
		cep->snd_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_snd */

#ifdef __udp_can_rcv

/*
 *  udp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

ER
UDP_CAN_RCV (T_UDP_CEP *cep, ER error)
{
	if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꤹ롣*/
		cep->error = error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		error = rel_wai(cep->rcv_tskid);
		cep->rcv_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_rcv */

#ifdef __udp_snd_dat

/*
 *  udp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
UDP_SND_DAT (ID cepid, T_IPEP *p_dstaddr, void *data, int_t len, TMO tmout)
{
	T_UDP_CEP	*cep;
	ER		error;

	/* p_dstaddr ޤ data  NULL tmout  TMO_NBLK ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || tmout == TMO_NBLK)
		return E_PAR;

	/* ǡĹå롣*/
	if (len < 0 || len + IP_HDR_SIZE + UDP_HDR_SIZE > IF_MTU)
		return E_PAR;

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&p_dstaddr->ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/*
	 *  ݡֹ椬 UDP_PORTANY ʤ顢ưǳƤ롣
	 */
	if (cep->myaddr.portno == UDP_PORTANY) {
		if ((error = UDP_ALLOC_AUTO_PORT(cep)) != E_OK)
			return error;
		}
	
	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (cep->snd_tskid != TA_NULL) {

		/* Υ֥å󥰥ǥڥǥ */
		error = E_QOVR;

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		}
	else {
		/* ߤΥ̻ҤϿ롣*/
		get_tid(&(cep->snd_tskid));

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꥻåȤ롣*/
		cep->error = E_OK;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ѥåȤ롣*/
		error = UDP_SEND_DATA(cep, p_dstaddr, data, len, tmout);

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼֤*/
		if (error == E_RLWAI)
			error = cep->error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */
		}

	return error;
	}

#endif	/* of #ifdef __udp_snd_dat */

#ifdef __udp_rcv_dat

/*
 *  udp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
UDP_RCV_DAT (ID cepid, T_IPEP *p_dstaddr, void *data, int_t len, TMO tmout)
{
	T_NET_BUF	*input;
	T_UDP_CEP	*cep;
	T_UDP_HDR	*udph;
	ER_UINT		error;
	uint_t		ulen, uhoff;

	/* p_dstaddr ޤ data  NULL len < 0 tmout  TMO_NBLK ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || len < 0 || tmout == TMO_NBLK)
		return E_PAR;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/* ̿üå롣*/
	syscall(wai_sem(cep->semid_lock));

	if (cep->rcv_tskid != TA_NULL) {

		/* Υ֥å󥰥ǥڥǥ */
		error = E_QOVR;

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		}
	else {

		/* ߤΥ̻ҤϿ롣*/
		get_tid(&(cep->rcv_tskid));

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꥻåȤ롣*/
		cep->error = E_OK;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));

		/* ϤޤԤġ*/
		if (cep->cb_netbuf != NULL) {

			/*
			 *  ˤϡХåؿ椫
			 *  udp_rcv_dat ƤӽФƤ뤳Ȥˤʤꡢ
			 *  ǤϺѤߤǤ롣
			 */
			input = cep->cb_netbuf;
			cep->cb_netbuf = NULL;
			}
		else if ((error = trcv_dtq(cep->rcvqid, (intptr_t*)&input, tmout)) != E_OK) {

#ifdef UDP_CFG_EXTENTIONS

			/* Ԥȯ顼֤*/
			if (error == E_RLWAI)
				error = cep->error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

			cep->rcv_tskid = TA_NULL;
			return error;
			}

		/* p_dstaddr ꤹ롣*/
		uhoff = (uint_t)GET_UDP_HDR_OFFSET(input);
		udph = GET_UDP_HDR(input, uhoff);
		p_dstaddr->portno = ntohs(udph->sport);
		IN_COPY_TO_HOST(&p_dstaddr->ipaddr, input);

		/* ǡХåե˰ܤ*/
		ulen = ntohs(udph->ulen);
		if (ulen - UDP_HDR_SIZE > len)
			error = E_BOVR;
		else {
			len   =    (uint_t)(ulen - UDP_HDR_SIZE);
			error = (ER_UINT)(ulen - UDP_HDR_SIZE);
			}

		memcpy(data, GET_UDP_SDU(input, uhoff), (size_t)len);

		syscall(rel_net_buf(input));

		cep->rcv_tskid = TA_NULL;
		}

	return error;
	}

#endif	/* of #ifdef __udp_rcv_dat */

#endif	/* of #ifdef UDP_CFG_NON_BLOCKING */
