/*
 *  TINET (UDP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udpn_usrreq_nblk.c 1.7 2017/6/1 8:49:30 abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must ceproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_usrreq.c	8.6 (Berkeley) 5/23/95
 * $FreeBSD: src/sys/netinet/udp_usrreq.c,v 1.49.2.2 1999/08/29 16:29:58 peter Exp $
 */

#ifdef __udp_can_snd_nblk

/*
 *  udp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

ER
UDP_CAN_SND (T_UDP_CEP *cep, ER error)
{
	if (cep->snd_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (IS_PTR_DEFINED(cep->callback))

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)error);
#else
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_SND_DAT, (void*)&error);
#endif
		else
			error = E_OBJ;
		cep->snd_p_dstaddr = NULL;
		}
	else if (cep->snd_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꤹ롣*/
		cep->error = error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		error = rel_wai(cep->snd_tskid);
		cep->snd_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_snd_nblk */

#ifdef __udp_can_rcv_nblk

/*
 *  udp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

ER
UDP_CAN_RCV (T_UDP_CEP *cep, ER error)
{
	if (cep->rcv_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (IS_PTR_DEFINED(cep->callback))

#ifdef TCP_CFG_NON_BLOCKING_COMPAT14
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)error);
#else
			(*cep->callback)(GET_UDP_CEPID(cep), TFN_UDP_RCV_DAT, (void*)&error);
#endif
		else
			error = E_OBJ;
		cep->rcv_p_dstaddr = NULL;
		}
	else if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */

#ifdef UDP_CFG_EXTENTIONS

		/* Ԥȯ顼ꤹ롣*/
		cep->error = error;

#endif	/* of #ifdef UDP_CFG_EXTENTIONS */

		error = rel_wai(cep->rcv_tskid);
		cep->rcv_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

#endif	/* of #ifdef __udp_can_rcv_nblk */

#ifdef __udp_snd_dat_nblk

/*
 *  udp_snd_dat -- ѥåȤɸൡǽ
 */

ER_UINT
UDP_SND_DAT (ID cepid, T_IPEP *p_dstaddr, void *data, int_t len, TMO tmout)
{
	T_UDP_CEP	*cep;
	ER		error;

	/* p_dstaddr ޤ data  NULL ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL)
		return E_PAR;

	/* ǡĹå롣*/
	if (len < 0 || len + IP_HDR_SIZE + UDP_HDR_SIZE > IF_MTU)
		return E_PAR;

#if (API_PROTO == API_PROTO_IPV6) && !defined(API_CFG_IP4MAPPED_ADDR)

	/*
	 * API  IPv6  IPv4 ͱƥɥ쥹ǧƤʤΤˤ⤫餺
	 * IPv4 ͱƥɥ쥹ꤵ줿饨顼
	 */
	if (in6_is_addr_ipv4mapped(&p_dstaddr->ipaddr))
		return E_PAR;

#endif	/* of #if (API_PROTO == API_PROTO_IPV6) && !defined(DAPI_CFG_IP4MAPPED_ADDR) */

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/*
	 *  ݡֹ椬 UDP_PORTANY ʤ顢ưǳƤ롣
	 */
	if (cep->myaddr.portno == UDP_PORTANY) {
		if ((error = UDP_ALLOC_AUTO_PORT(cep)) != E_OK)
			return error;
		}

	/*
	 * ॢȤå롣
	 */
	if (tmout == TMO_NBLK) {	/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->snd_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			cep->snd_p_dstaddr = p_dstaddr;
			cep->snd_data	= data;
			cep->snd_len	= len;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			cep->flags |= UDP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_UDP_POST_OUTPUT);
			error = E_WBLK;
			}
		}
	else {				/* Υ֥å󥰥 */
	
		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->snd_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->snd_tskid));

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ѥåȤ롣*/
			error = UDP_SEND_DATA(cep, p_dstaddr, data, len, tmout);
			}
		}

	return error;
	}

#endif	/* of #ifdef __udp_snd_dat_nblk */

#ifdef __udp_rcv_dat_nblk

/*
 *  udp_rcv_dat -- ѥåȤμɸൡǽ
 */

ER_UINT
UDP_RCV_DAT (ID cepid, T_IPEP *p_dstaddr, void *data, int_t len, TMO tmout)
{
	T_NET_BUF	*input;
	T_UDP_CEP	*cep;
	T_UDP_HDR	*udph;
	ER_UINT		error;
	uint_t		ulen, uhoff;

	/* p_dstaddr ޤ data  NULL len < 0 ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || len < 0)
		return E_PAR;

	/* UDP ̿ü ID å롣*/
	if (!VALID_UDP_CEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CEP(cepid);

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CEP(cep))
		return E_NOEXS;

	/*
	 * ॢȤå롣
	 */

	if (tmout == TMO_NBLK) {	/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->rcv_p_dstaddr != NULL)

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

		else if (cep->rcv_tskid != TA_NULL)

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
		else {
			cep->rcv_p_dstaddr = p_dstaddr;
			cep->rcv_data	= data;
			cep->rcv_len	= len;
			error = E_WBLK;
			}

		/* ̿üå롣*/
		syscall(sig_sem(cep->semid_lock));
		return error;
		}
	else {				/* Υ֥å󥰥 */

		/* ̿üå롣*/
		syscall(wai_sem(cep->semid_lock));

		if (cep->rcv_p_dstaddr != NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->rcv_tskid != TA_NULL) {

			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->rcv_tskid));

			/* ̿üå롣*/
			syscall(sig_sem(cep->semid_lock));

			/* ϤޤԤġ*/
			if (cep->cb_netbuf != NULL) {

				/*
				 *  ˤϡХåؿ椫
				 *  udp_rcv_dat ƤӽФƤ뤳Ȥˤʤꡢ
				 *  ǤϺѤߤǤ롣
				 */
				input = cep->cb_netbuf;
				cep->cb_netbuf = NULL;
				}
			else if ((error = trcv_dtq(cep->rcvqid, (intptr_t*)&input, tmout)) != E_OK) {
				cep->rcv_tskid = TA_NULL;
				return error;
				}

			/* p_dstaddr ꤹ롣*/
			uhoff = (uint_t)GET_UDP_HDR_OFFSET(input);
			udph = GET_UDP_HDR(input, uhoff);
			p_dstaddr->portno = ntohs(udph->sport);
			IN_COPY_TO_HOST(&p_dstaddr->ipaddr, input);

			/* ǡХåե˰ܤ*/
			ulen = ntohs(udph->ulen);
			if (ulen - UDP_HDR_SIZE > len)
				error = E_BOVR;
			else {
				len   =     (int_t)(ulen - UDP_HDR_SIZE);
				error = (ER_UINT)(ulen - UDP_HDR_SIZE);
				}

			memcpy(data, GET_UDP_SDU(input, uhoff), (size_t)len);

			syscall(rel_net_buf(input));

			cep->rcv_tskid = TA_NULL;
			}
		return error;
		}
	}

#endif	/* of #ifdef __udp_rcv_dat_nblk */
