/*
 *  TINET (TCP/IP Protocol Stack)
 * 
 *  Copyright (C) 2001-2017 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡξȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: in6_subr.c 1.7 2017/6/1 8:49:42 abe $
 */

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Copyright (c) 1985, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#include <string.h>

#ifdef TARGET_KERNEL_ASP

#include <kernel.h>
#include <sil.h>
#include "kernel_cfg.h"

#endif	/* of #ifdef TARGET_KERNEL_ASP */

#ifdef TARGET_KERNEL_JSP

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#endif	/* of #ifdef TARGET_KERNEL_JSP */

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_loop.h>
#include <net/if_ppp.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <net/net.h>
#include <net/net_endian.h>
#include <net/net_var.h>
#include <net/net_buf.h>
#include <net/net_timer.h>

#include <netinet/in.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>

#include <netinet6/nd6.h>
#include <netinet6/ah.h>

#include <net/if_var.h>

/*
 *  in6_make_ipv4mapped -- IPv4 ͱƥɥ쥹롣
 *
 *  :
 *    src ϥۥȥХȥ
 *
 */

T_IN6_ADDR *
in6_make_ipv4mapped (T_IN6_ADDR *dst, T_IN4_ADDR src)
{
	dst->s6_addr32[0] = ULONG_C(0x00000000);
	dst->s6_addr32[1] = ULONG_C(0x00000000);
	dst->s6_addr32[2] = IPV6_ADDR_INT32_0000FFFF;
	dst->s6_addr32[3] = htonl(src);

	return dst;
	}

#ifdef _IP6_CFG

#if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in6_rtinit -- 롼ƥɽ롣
 */

void
in6_rtinit (void)
{
	int_t ix;

	for (ix = 0; ix < NUM_IN6_STATIC_ROUTE_ENTRY; ix ++)
		routing6_tbl[ix].flags = IN_RTF_DEFINED;

	for ( ; ix < NUM_IN6_ROUTE_ENTRY; ix ++)
		routing6_tbl[ix].flags = 0;
	}

/*
 *  in6_rtnewentry -- ȥ롣
 */

T_IN6_RTENTRY *
in6_rtnewentry (uint8_t flags, uint32_t tmo)
{
	SYSTIM		now;
	T_IN6_RTENTRY	*rt, *frt = NULL;
	int_t		ix;

	/* ȥõ*/
	for (ix = NUM_IN6_STATIC_ROUTE_ENTRY; ix < NUM_IN6_ROUTE_ENTRY; ix ++) {
		rt = &routing6_tbl[ix];
		if ((routing6_tbl[ix].flags & IN_RTF_DEFINED) == 0) {
			frt = rt;
			break;
			}
		}

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	if (frt == NULL) {
		/* ʤС֤ͭäȤûȥˤ롣*/
		T_IN6_RTENTRY	*srt = NULL;
		int_t		diff, sdiff = INT_MAX;

		syscall(wai_sem(SEM_IN6_ROUTING_TBL));
		for (ix = NUM_IN6_STATIC_ROUTE_ENTRY; ix < NUM_IN6_ROUTE_ENTRY; ix ++) {
			rt = &routing6_tbl[ix];
			diff = (int_t)(rt->expire - now);
			if (diff <= 0) {	/* rt->expire <= now */
				/* ˡ֤ͭ᤮Ƥ롣*/
				frt = rt;
				break;
				}
			else if (diff < sdiff) {
				srt = rt;
				sdiff = diff;
				}
			}
		if (frt == NULL)
			frt = srt;
		frt->flags = 0;
		syscall(sig_sem(SEM_IN6_ROUTING_TBL));
		}

	frt->flags  = (uint8_t)(flags | IN_RTF_DEFINED);
	frt->expire = now + tmo / SYSTIM_HZ;
	return frt;
	}

/*
 *  in6_rttimer -- 롼ƥɽδޡ
 */

void
in6_rttimer (void)
{
	SYSTIM	now;
	int_t	ix;

	/* expire ñ̤ [s]*/
	syscall(get_tim(&now));
	now /= SYSTIM_HZ;

	syscall(wai_sem(SEM_IN6_ROUTING_TBL));
	for (ix = NUM_IN6_STATIC_ROUTE_ENTRY; ix < NUM_IN6_ROUTE_ENTRY; ix ++)
		if ((routing6_tbl[ix].flags & IN_RTF_DEFINED) &&
		    (int_t)(routing6_tbl[ix].expire - now) <= 0)
			routing6_tbl[ix].flags = 0;
	syscall(sig_sem(SEM_IN6_ROUTING_TBL));
	}

#endif	/* of #if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0 */

#if NUM_IN6_HOSTCACHE_ENTRY > 0

/*
 *  ۥȥå
 */

static T_IN6_HOSTCACHE_ENTRY in6_hostcache[NUM_IN6_HOSTCACHE_ENTRY];

#endif	/* of #if NUM_IN6_HOSTCACHE_ENTRY > 0 */

/*
 *  in6_lookup_ifaddr -- ͥåȥ󥿥ե˳ƤƤ륢ɥ쥹õ롣
 */

T_IN6_IFADDR *
in6_lookup_ifaddr (T_IFNET *ifp, const T_IN6_ADDR *addr)
{
	int_t ix;

	for (ix = NUM_IN6_IFADDR_ENTRY; ix -- > 0; ) {
		if ((ifp->in6_ifaddrs[ix].flags & IN6_IFF_DEFINED) &&
		    IN6_ARE_ADDR_EQUAL(addr, &ifp->in6_ifaddrs[ix].addr))
			return &ifp->in6_ifaddrs[ix];
		}
	return NULL;
	}

/*
 *  in6_lookup_multi -- ͥåȥ󥿥եΥޥ㥹ȥɥ쥹򸡺롣
 */

bool_t
in6_lookup_multi (T_IFNET *ifp, const T_IN6_ADDR *maddr)
{
	int_t ix;

	for (ix = MAX_IN6_MADDR_CNT; ix -- > 0; )
		if (IN6_ARE_ADDR_EQUAL(maddr, &ifp->in6_maddrs[ix]))
			return true;
	return false;
	}

/*
 *  in6_set_header -- IPv6 إåꤹ롣
 */

ER
in6_set_header (T_NET_BUF *nbuf, uint_t len,
                const T_IN6_ADDR *dstaddr, const T_IN6_ADDR *srcaddr,
                uint8_t next, uint8_t hlim)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IP6_HDR	*ip6h;
	T_IN6_IFADDR	*ia;

	/*
	 *  襢ɥ쥹ˤդ路ɥ쥹
	 *  ͥåȥ󥿥եõѤ롣
	 */
	if (srcaddr == NULL || !IN6_IS_ADDR_UNSPECIFIED(srcaddr))
		;
	else if ((ia = in6_ifawithifp(ifp, dstaddr)) == NULL)
		return E_SYS;
	else
		srcaddr = &ia->addr;

	/* IPv6 إåꤹ롣*/
	ip6h		= GET_IP6_HDR(nbuf);
	ip6h->vcf	= htonl(IP6_MAKE_VCF(IPV6_VERSION, 0));
	ip6h->plen	= htons(len);
	ip6h->next	= next;
	ip6h->hlim	= hlim;

	if (dstaddr == NULL)
		memset(&ip6h->dst, 0, sizeof(T_IN6_ADDR));
	else
		ip6h->dst = *dstaddr;

	if (srcaddr == NULL)
		memset(&ip6h->src, 0, sizeof(T_IN6_ADDR));
	else
		ip6h->src = *srcaddr;

	return E_OK;
	}

/*
 *  in6_get_datagram -- IPv6 ǡإåꤹ롣
 */

ER
in6_get_datagram (T_NET_BUF **nbuf, uint_t len, uint_t maxlen,
                  const T_IN6_ADDR *dstaddr, const T_IN6_ADDR *srcaddr,
                  uint8_t next, uint8_t hlim, ATR nbatr, TMO tmout)
{
	ER		error;
	uint_t		align;

	/* ǡĹ 4 ƥåȶĴ롣	*/
	align = (len + 3) >> 2 << 2;

	/* ͥåȥХåե롣	*/
	if ((error = tget_net_buf_ex(nbuf, IF_IP6_HDR_SIZE + align,
	                                   IF_IP6_HDR_SIZE + maxlen, nbatr, tmout)) != E_OK)
		return error;

	/*
	 *  礭ʥΥͥåȥХåեΤĹĴ롣
	 *  꾮ʥΥͥåȥХåեγϡɥХåե
	 *  ʥԡǽǻѤ졢ºݤޤǡǡϷǤʤ
	 */
	if ((nbatr & NBA_SEARCH_ASCENT) != 0)
		(*nbuf)->len = IF_IP6_HDR_SIZE + len;

	/* IPv6 إåꤹ롣*/
	if ((error = in6_set_header(*nbuf, len, dstaddr, srcaddr, next, hlim)) != E_OK)
		return error;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset(GET_IP6_SDU(*nbuf) + len, 0, align - len);

	return E_OK;
	}

/*
 *  in6_get_maxnum_ifaddr -- 󥿥եǽʺ祢ɥ쥹֤
 */

uint_t
in6_get_maxnum_ifaddr (void)
{
	return NUM_IN6_IFADDR_ENTRY;
	}

/*
 *  in6_get_ifaddr -- 󥿥եꤵƤ륢ɥ쥹֤
 */

const T_IN6_ADDR *
in6_get_ifaddr (int_t index)
{
	T_IFNET		*ifp = IF_GET_IFNET();

	if (index < NUM_IN6_IFADDR_ENTRY &&
	    (ifp->in6_ifaddrs[index].flags & IN6_IFF_DEFINED))
		return &ifp->in6_ifaddrs[index].addr;
	else
		return NULL;
	}

/*
 *  ipv62str -- IPv6 ɥ쥹ʸѴ롣
 */

char *
ipv62str (char *buf, const T_IN6_ADDR *p_addr)
{
	static char	addr_sbuf[NUM_IPV6ADDR_STR_BUFF][sizeof("0123:4567:89ab:cdef:0123:4567:255.255.255.255")];
	static int_t	bix = NUM_IPV6ADDR_STR_BUFF;

	bool_t	omit = false, zero = false;
	char	*start;
	int_t	ix, len6;

	if (buf == NULL) {
		syscall(wai_sem(SEM_IP2STR_BUFF_LOCK));
		buf = addr_sbuf[-- bix];
		if (bix <= 0)
			bix = NUM_IPV6ADDR_STR_BUFF;
		syscall(sig_sem(SEM_IP2STR_BUFF_LOCK));
		}

	start = buf;
	if (p_addr == NULL || IN6_IS_ADDR_UNSPECIFIED(p_addr)) {
		*buf ++ = '0';
		*buf ++ = ':';
		*buf ++ = ':';
		*buf ++ = '0';
		}
	else {
		if (IN6_IS_ADDR_V4MAPPED(p_addr))
			len6 = sizeof(T_IN6_ADDR) / 2 - 2;
		else
			len6 = sizeof(T_IN6_ADDR) / 2;
		for (ix = 0; ix < len6; ix ++) {
			if (omit) {
				buf += convert_hexdigit(buf, ntohs(p_addr->s6_addr16[ix]), 16, 0, ' '); 
				if (ix < 7)
					*buf ++ = ':';
				}
			else if (ix > 0 && ix < 7 && p_addr->s6_addr16[ix] == 0)
				zero = true;
			else {
				if (zero) {
					omit = true;
					*buf ++ = ':';
					}
				buf += convert_hexdigit(buf, ntohs(p_addr->s6_addr16[ix]), 16, 0, ' '); 
				if (ix < 7)
					*buf ++ = ':';
				}
			}

		if (len6 == sizeof(T_IN6_ADDR) / 2 - 2) {
			T_IN4_ADDR ipv4addr;

			ipv4addr = ntohl(p_addr->s6_addr32[3]);
			buf += convert_hexdigit(buf, (uint_t)((ipv4addr >> 24) & 0xff), 10, 0, ' ');
			*(buf ++) = '.';
			buf += convert_hexdigit(buf, (uint_t)((ipv4addr >> 16) & 0xff), 10, 0, ' ');
			*(buf ++) = '.';
			buf += convert_hexdigit(buf, (uint_t)((ipv4addr >>  8) & 0xff), 10, 0, ' ');
			*(buf ++) = '.';
			buf += convert_hexdigit(buf, (uint_t)((ipv4addr      ) & 0xff), 10, 0, ' ');
			}
		}
	*buf = '\0';
	return start;
	}

/*
 *  in6_cksum -- IPv6 Υȥ󥹥ݡإإåΥå׻롣
 *
 *  : ͤϥͥåȥХȥ
 */

uint16_t
in6_cksum (T_NET_BUF *nbuf, uint8_t proto, uint_t off, uint_t len)
{
	uint32_t	sum;
	uint_t		align;

	/* 4 ƥåȶΥǡĹ */
	align = (len + 3) >> 2 << 2;

	/* 4 ƥåȶޤǥѥǥ󥰤롣*/
	if (align > len)
		memset((uint8_t*)nbuf->buf + off + len, 0, align - len);

	sum = in_cksum_sum(nbuf->buf + off, align)
	    + in_cksum_sum(&GET_IP6_HDR(nbuf)->src, sizeof(T_IN6_ADDR) * 2)
	    + len + proto;
	sum = in_cksum_carry(sum);

	return ~htons((uint16_t)sum);
	}

/*
 *  get_ip6_hdr_size -- ĥإåޤ᤿ IPv6 إåĹ֤
 */

uint_t
get_ip6_hdr_size (T_NET_BUF *nbuf)
{
	T_IP6_HDR	*iph = GET_IP6_HDR(nbuf);
	uint_t		size = IP6_HDR_SIZE, hsize;
	uint8_t		curr = iph->next, next;
	uint8_t		*hdr = ((uint8_t *)iph) + IP6_HDR_SIZE;

	while (1) {
		next = *hdr;
		if (curr ==IPPROTO_NONE)		/* إå̵			*/
			break;
		else if (curr == IPPROTO_FRAGMENT)	/* Ҳ			*/
			hsize = sizeof(T_IP6_FRAG_HDR);
		else if (curr == IPPROTO_AH)		/* IPv6 ǧ			*/
			hsize = (((T_IP6_AH_HDR *)hdr)->len + 2) * 4;
		else if (curr == IPPROTO_HOPOPTS ||	/*  (Hop-by-Hop) ץ	*/
		         curr == IPPROTO_DSTOPTS ||	/* IPv6 ץ		*/
		         curr == IPPROTO_ROUTING)	/* ϩ			*/
			hsize = (((T_IP6_EXT_HDR *)hdr)->len + 1) * 8;
		else
			break;
		size += hsize;
		hdr  += hsize;
		curr = next;
		}
	return size;
	}

/*
 *  in6_plen2pmask -- ץեåĹޥ롣
 */

void
in6_plen2pmask (T_IN6_ADDR *mask, uint_t prefix_len)
{
	uint8_t	*ptr, bit;

	memset(mask->s6_addr + prefix_len / 8, 0, (128 - prefix_len + 7) / 8);
	for (ptr = mask->s6_addr; prefix_len > 0; ptr ++) {
		for (bit = 0x80; bit && (prefix_len > 0); prefix_len --) {
			*ptr |= bit;
			bit >>= 1;
			}
		}
	}

/*
 *  in6_rtalloc -- 롼ƥɽõ롣
 */

const T_IN6_ADDR *
in6_rtalloc (T_IFNET *ifp, const T_IN6_ADDR *dst)
{
	if (IN6_IS_ADDR_LINKLOCAL(dst) || IN6_IS_ADDR_MULTICAST(dst))
		return dst;
	else {
		T_IN6_IFADDR	*ia;
		SYSTIM		now;
		int_t		ix;

		/*
		 *  ȥ륢ɥ쥹ǽʥХ˥ɥ쥹ξϡ
		 *  ƱΥΡɤǤ뤫å롣
		 */

		syscall(get_tim(&now));
		now /= SYSTIM_HZ;

		/* 侩ͭΥɥ쥹õ롣*/
		for (ix = NUM_IN6_IFADDR_ENTRY; ix -- > 0; ) {
			ia = &ifp->in6_ifaddrs[ix];
			if (IFA6_IS_READY(ia) &&
			    in6_are_prefix_equal(dst, &ia->addr, ia->prefix_len) &&
			    (int32_t)(ia->lifetime.preferred - now) > 0) {
		                   /* ia->lifetime.preferred > now */
				return dst;
				}
			}

		/* ͭΥɥ쥹õ롣*/
		for (ix = NUM_IN6_IFADDR_ENTRY; ix -- > 0; ) {
			ia = &ifp->in6_ifaddrs[ix];
			if (IFA6_IS_READY(ia) &&
			    in6_are_prefix_equal(dst, &ia->addr, ia->prefix_len) &&
			    (int32_t)(ia->lifetime.expire - now) > 0)
		                   /* ia->lifetime.expire > now */
				return dst;
			}

		/*
		 *  ץեåõ롣
		 */
		if (nd6_onlink_prefix_lookup (dst) != NULL)
			return dst;

		/*
		 *  Ūϩɽõ롣
		 */

#if NUM_IN6_ROUTE_ENTRY > 0

		syscall(wai_sem(SEM_IN6_ROUTING_TBL));
		for (ix = NUM_IN6_ROUTE_ENTRY; ix --; ) {
			if ((routing6_tbl[ix].flags & IN_RTF_DEFINED) &&
			    in6_are_prefix_equal(dst, &routing6_tbl[ix].target,
			                               routing6_tbl[ix].prefix_len)) {

				/*
				 *  ľˤ륨ȥϡ֤ͭڤĹ롣
				 *  expire ñ̤ [s]
				 *  TMO_IN_REDIRECT ñ̤ [ms]
				 */
				if (ix > NUM_IN6_STATIC_ROUTE_ENTRY) {
					SYSTIM	now;

					syscall(get_tim(&now));
					routing6_tbl[ix].expire = now / SYSTIM_HZ + TMO_IN_REDIRECT / 1000;
					}

				syscall(sig_sem(SEM_IN6_ROUTING_TBL));
				return &routing6_tbl[ix].gateway;
				}
			}
		syscall(sig_sem(SEM_IN6_ROUTING_TBL));

#endif	/* of #if NUM_IN6_ROUTE_ENTRY > 0 */

		/*
		 *  ǥեȥ롼ꥹȤõ롣
		 */
		return nd6_router_lookup();
		}
	}

#if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0

/*
 *  in6_gateway_lookup -- 롼ƥɽΥ롼õ롣
 */

T_IN6_RTENTRY *
in6_gateway_lookup (const T_IN6_ADDR *gw)
{
	int_t	ix;

	for (ix = NUM_IN6_ROUTE_ENTRY; ix --; )
		if ((routing6_tbl[ix].flags & IN_RTF_DEFINED) &&
		    IN6_ARE_ADDR_EQUAL(&routing6_tbl[ix].gateway, gw))
			return &routing6_tbl[ix];
	return NULL;
	}

/*
 *  in6_rtredirect -- 롼ƥɽ˥ȥϿ롣
 *
 *    :  tmo ñ̤ [ms]
 */

void
in6_rtredirect (const T_IN6_ADDR *gateway, const T_IN6_ADDR *target, uint_t prefix_len, uint8_t flags, uint32_t tmo)
{
	T_IN6_RTENTRY	*frt;

	frt = in6_rtnewentry(flags, tmo);
	frt->gateway    = *gateway;
	frt->target     = *target;
	frt->prefix_len = prefix_len;
	}

#endif	/* of #if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0 */

#if NUM_IN6_HOSTCACHE_ENTRY > 0

/*
 *  in6_hostcache_lookup -- IPv6 ۥȥåõ롣
 */

static T_IN6_HOSTCACHE_ENTRY*
in6_hostcache_lookup (const T_IN6_ADDR *dst)
{
	int_t ix;

	for (ix = NUM_IN6_HOSTCACHE_ENTRY; ix -- > 0; ) {
		if (IN6_ARE_ADDR_EQUAL(dst, &in6_hostcache[ix].dst))
			return &in6_hostcache[ix];
		}
	return NULL;
	}

/*
 *  in6_hostcache_update -- IPv6 ۥȥå򹹿롣
 */

void
in6_hostcache_update (T_IN6_ADDR *dst, uint32_t mtu)
{
	T_IN6_HOSTCACHE_ENTRY	*hc;
	SYSTIM	now, old;
	int_t	ix, oix;

	syscall(get_tim(&now));

	/* ϿƤ뤫õ롣*/
	if ((hc = in6_hostcache_lookup (dst)) == NULL) {

		/* Υۥȥåõ*/
		for (ix = NUM_IN6_HOSTCACHE_ENTRY; ix -- > 0; ) {
			if (IN6_IS_HOSTCACHE_FREE(&in6_hostcache[ix]))
				break;
			}

		if (ix < 0) {
			/*
			 *  ̵ϡ֤ͭڤ֤
			 *  Ǥûۥȥåִ롣
			 */
			old = now - 1;
			oix = 0;
			for (ix = NUM_IN6_HOSTCACHE_ENTRY; ix -- > 0; ) {
				hc = &in6_hostcache[ix];
				if (IN6_IS_HOSTCACHE_BUSY(hc) && (int32_t)(hc->expire - old) < 0) {
				                                        /* hc->expire < old */
					oix = ix;
					old = hc->expire;
					}
				}
			ix = oix;
			}
		hc = &in6_hostcache[ix];
		}
	else if (mtu > hc->mtu &&
	         (int32_t)(hc->expire - now) >= (IN6_HOSTCACHE_EXPIRE - IN6_HOSTCACHE_INCREASE)) {

		/*
		 *  ϿƤơ MTU ϿƤ MTU 礭Ȥ
		 *  IN6_HOSTCACHE_INCREASEʿ侩 10 ʬ˴֤Ϲʤ
		 */
		return;
		}
	hc->dst    = *dst;
	hc->expire = now + IN6_HOSTCACHE_EXPIRE;
	hc->mtu    = mtu;
	}

/*
 *  in6_hostcache_getmtu -- IPv6 ۥȥå򤫤 MTU 롣
 *
 *    ͤ 0 ǤСۥȥåϿƤʤ
 */

uint32_t
in6_hostcache_getmtu (const T_IN6_ADDR *dst)
{
	T_IN6_HOSTCACHE_ENTRY	*hc;

	/* ϿƤ뤫õ롣*/
	if ((hc = in6_hostcache_lookup(dst)) == NULL)
		return 0;
	else
		return hc->mtu;
	}

/*
 *  in6_hostcache_timer -- IPv6 ۥȥå幹ޡ
 *
 *    1üǵư롣
 */

static void
in6_hostcache_timer (void)
{
	static int_t interval = IN6_HOSTCACHE_PRUNE / SYSTIM_HZ;

	SYSTIM	now;

	interval --;
	if (interval <= 0) {
		syscall(get_tim(&now));
		interval = IN6_HOSTCACHE_PRUNE / SYSTIM_HZ;
		}
	}

#endif	/* of #if NUM_IN6_HOSTCACHE_ENTRY > 0 */

/*
 *  in6_timer -- IPv6 ̥ޡ
 *
 *    1üǵư롣
 */

static void
in6_timer (void)
{
#if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0

	in6_rttimer();

#endif	/* of #if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0 */

#ifdef IP6_CFG_FRAGMENT

	frag6_timer();

#endif	/* of #ifdef IP6_CFG_FRAGMENT */

#if NUM_IN6_HOSTCACHE_ENTRY > 0

	in6_hostcache_timer();

#endif	/* of #if NUM_IN6_HOSTCACHE_ENTRY > 0 */

	timeout((callout_func)in6_timer, NULL, IN_TIMER_TMO);
	}

/*
 *  in6_init -- IPv6 ̵ǽ롣
 */

void
in6_init (void)
{
#if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0

	in6_rtinit();

#endif	/* of #if NUM_IN6_REDIRECT_ROUTE_ENTRY > 0 */

	timeout((callout_func)nd6_timer, NULL, ND6_TIMER_TMO);
	timeout((callout_func)in6_timer, NULL, IN_TIMER_TMO);
	}

/*
 *  in6_is_dstaddr_accept -- 襢ɥ쥹Ȥå롣
 */

bool_t
in6_is_dstaddr_accept (const T_IN6_ADDR *myaddr, const T_IN6_ADDR *dstaddr)
{
	if (IN6_IS_ADDR_UNSPECIFIED(myaddr))
		return in6_lookup_ifaddr(IF_GET_IFNET(), dstaddr) != NULL;
	else
		return IN6_ARE_ADDR_EQUAL(dstaddr, myaddr);
	}

#if defined(DHCP6_CLI_CFG)

/*
 *  in6_add_ifaddr -- 󥿥ե IPv6 ɥ쥹ꤹ롣
 *
 *    vltime  pltime ñ̤[s]
 */

static ER
in6_add_ifaddr (T_IN6_ADDR *addr, uint_t prefix_len,
                uint32_t vltime, uint32_t pltime)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IN6_IFADDR	*ia = NULL;
	int_t		ix;

	/* Υȥ꡼õ*/
	ix = 0;
	while (true) {
		ia = in6ifa_ifpwithix(ifp, ix ++);

		/* ̵Х顼 */
		if (ia == NULL)
			return E_OBJ;

		if ((ia->flags & IN6_IFF_DEFINED) == 0)
			break;
		}

	/* Ͽ롣*/
	return in6_update_ifa(ifp, ia, addr, prefix_len, vltime, pltime,
	                      IN6_RTR_IX_UNREACH, ND6_PREFIX_IX_INVALID, 0);
	}

/*
 *  in6_upd_ifaddr -- 󥿥եꤵƤ IPv6 ɥ쥹򹹿롣
 *
 *    ϿƤʤСɲä롣
 *    vltime  pltime ñ̤[s]
 */

ER
in6_upd_ifaddr (T_IN6_ADDR *addr, uint_t prefix_len,
                uint32_t vltime, uint32_t pltime)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	T_IN6_IFADDR	*ia;
	int_t		ix;

	/*
	 *  ɥ쥹פ륨ȥ꡼õ
	 *  ̵Ͽ롣
	 */
	if ((ix = in6_addr2ifaix(addr)) == IPV6_IFADDR_IX_INVALID)
		return in6_add_ifaddr(addr, prefix_len, vltime, pltime);

	/*
	 *  ǥåֹ椫顢ȥ꡼Ѵ롣
	 *  顼ˤʤʤϤǤ뤬ǧ롣
	 */
	if ((ia = in6ifa_ifpwithix (ifp, ix)) == NULL)
		return E_OBJ;

	/* 롣*/
	return in6_update_ifa(ifp, ia, addr, prefix_len, vltime, pltime,
	                      IN6_RTR_IX_UNREACH, ND6_PREFIX_IX_INVALID, 0);
	}

/*
 *  in6_del_ifaddr -- 󥿥եꤵƤ IPv6 ɥ쥹롣
 */

ER
in6_del_ifaddr (T_IN6_ADDR *addr)
{
	T_IFNET		*ifp = IF_GET_IFNET();
	int_t		ix;

	/* ɥ쥹פ륨ȥ꡼õ*/
	if ((ix = in6_addr2ifaix(addr)) != IPV6_IFADDR_IX_INVALID) {

		/* ȥ꡼̵ˤ롣*/
		ifp->in6_ifaddrs[ix].flags &= ~IN6_IFF_DEFINED;
		return E_OK;
		}
	return E_PAR;
	}

#endif	/* of #if defined(DHCP6_CLI_CFG) */

#endif /* of #ifdef _IP6_CFG */
